
#define MKPOS_SCRIPT_NAME		"MKPosition"


forward OnTeleportPlayer( handle, playerid, index );
forward OnAreaBoundPlayer( handle, playerid, index );


#define MAX_POSITIONS						200
#define MAX_AREAS							50

#define TELEPORT_MODE_PLAYER			0
#define TELEPORT_MODE_VEHICLE			1


MKPOS_CreateInstance()
{
	return MKMM_CreateInstance( MKPOS_SCRIPT_NAME );
}
MKPOS_DestroyInstance( handle )
{
	return MKMM_DestroyInstance( MKPOS_SCRIPT_NAME, handle );
}

MKPOS_AddPosition( handle, Float:x, Float:y, Float:z, Float:a, i )
{
	return CallRemoteFunction( "MKPOS_AddPosition", "iffffi", handle, x, y, z, a, i );
}
MKPOS_DelPosition( handle, index )
{
	return CallRemoteFunction( "MKPOS_DelPosition", "ii", handle, index );
}
MKPOS_SetPosition( handle, index, Float:x, Float:y, Float:z, Float:a, i )
{
	return CallRemoteFunction( "MKPOS_SetPosition", "iiffffi", handle, index, x, y, z, a, i );
}

MKPOS_Teleport( handle, playerid, index, mode=TELEPORT_MODE_VEHICLE )
{
	return CallRemoteFunction( "MKPOS_Teleport", "iiii", handle, playerid, index, mode );
}
MKPOS_TeleportRand( handle, playerid, mode=TELEPORT_MODE_VEHICLE )
{
	return CallRemoteFunction( "MKPOS_TeleportRand", "iii", handle, playerid, mode );
}


MKPOS_AddArea( handle, Float:x_min, Float:y_min, Float:x_max, Float:y_max )
{
	return CallRemoteFunction( "MKPOS_AddArea", "iffff", handle, x_min, y_min, x_max, y_max );
}
MKPOS_DelArea( handle, index )
{
	return CallRemoteFunction( "MKPOS_DelArea", "ii", handle, index );
}
MKPOS_SetArea( handle, index, Float:x_min, Float:y_min, Float:x_max, Float:y_max )
{
	return CallRemoteFunction( "MKPOS_SetArea", "iiffff", handle, index, x_min, y_min, x_max, y_max );
}

MKPOS_EnableAreaBound( handle, enabled, disbound=0 )
{
	return CallRemoteFunction( "MKPOS_EnableAreaBound", "iii", handle, enabled, disbound );
}

MKPOS_SetPlayerAreaBound( handle, playerid, index )
{
	return CallRemoteFunction( "MKPOS_SetPlayerAreaBound", "iii", handle, playerid, index );
}
MKPOS_GetPlayerAreaBound( handle, playerid )
{
	return CallRemoteFunction( "MKPOS_GetPlayerAreaBound", "ii", handle, playerid );
}

MKPOS_GetPlayerArea( handle, playerid )
{
	return CallRemoteFunction( "MKPOS_GetPlayerArea", "ii", handle, playerid );
}
MKPOS_GetPlayerAreaByPos( handle, x, y )
{
	return CallRemoteFunction( "MKPOS_GetPlayerAreaByPos", "iff", handle, x, y );
}

#pragma unused MKPOS_CreateInstance, MKPOS_DestroyInstance, MKPOS_AddPosition, MKPOS_DelPosition,\
	MKPOS_SetPosition, MKPOS_Teleport, MKPOS_TeleportRand, MKPOS_AddArea, MKPOS_DelArea,\
	MKPOS_SetArea, MKPOS_EnableAreaBound, MKPOS_SetPlayerAreaBound, MKPOS_GetPlayerAreaBound,\
	MKPOS_GetPlayerArea, MKPOS_GetPlayerAreaByPos
