/*  Team Fortress San Andreas Capturepoint Management
 *
 *  (c) Copyright 2007, teh 1337 h4xx0r crew
 *
 */

#if defined _satf_capturepoints_included
	#endinput
#endif
#define _satf_capturepoints_included

#include <a_samp>
#include <satf_players>
#include <satf_text>

#define MAX_CAPPS 20
new satf_next_capp_id = 0;
#define CAPP_INVALID_ID -1
#define CAPP_TIMER_TICKRATE 1000

#define CAPP_ICON_OFFSET 0
#define CAPP_ICON_NEUTRAL 60
#define CAPP_ICON_ALPHA 59
#define CAPP_ICON_BETA 62

#define CAPP_OBJECT_NEUTRAL 3107
#define CAPP_OBJECT_CAPTURED 3030

#define CAPP_NUM_PROPS_INT 6
#define CAPP_OWNER 0
#define CAPP_TEAM_BASE 1
#define CAPP_STATUS_LIMIT 2
#define CAPP_STATUS 3
#define CAPP_OBJECT 4
#define CAPP_OBJECT_ID 5


#define CAPP_STATUS_DEFAULT_LIMIT 10

new satf_capp_int[MAX_CAPPS][CAPP_NUM_PROPS_INT];
new satf_capp_links[MAX_CAPPS][MAX_CAPPS];
new satf_capp_links_index[MAX_CAPPS];

#define CAPP_NUM_PROPS_FLOAT 4
#define CAPP_X 0
#define CAPP_Y 1
#define CAPP_Z 2
#define CAPP_RADIUS 3

new Float:satf_capp_float[MAX_CAPPS][CAPP_NUM_PROPS_FLOAT];

createCapturePoint(teamBase, beginStatus, statusLimit, Float:x, Float:y, Float:z, Float:radius) {
	if(satf_next_capp_id < MAX_CAPPS) {
		satf_capp_float[satf_next_capp_id][CAPP_X] = x;
		satf_capp_float[satf_next_capp_id][CAPP_Y] = y;
		satf_capp_float[satf_next_capp_id][CAPP_Z] = z;
		satf_capp_float[satf_next_capp_id][CAPP_RADIUS] = radius;
	
		satf_capp_int[satf_next_capp_id][CAPP_OWNER] = TEAM_NEUTRAL;
		satf_capp_int[satf_next_capp_id][CAPP_STATUS_LIMIT] = statusLimit;
		if(beginStatus <= statusLimit && beginStatus >= -statusLimit) {
			satf_capp_int[satf_next_capp_id][CAPP_STATUS] = beginStatus;
		} else {
			satf_capp_int[satf_next_capp_id][CAPP_STATUS] = 0;
		}
		satf_capp_int[satf_next_capp_id][CAPP_TEAM_BASE] = teamBase;
		satf_capp_int[satf_next_capp_id][CAPP_OBJECT] = CreateObject(CAPP_OBJECT_NEUTRAL,x,y,z,0,0,0);
		satf_capp_int[satf_next_capp_id][CAPP_OBJECT_ID] = CAPP_OBJECT_NEUTRAL;
		updateMapIcon(satf_next_capp_id, CAPP_ICON_NEUTRAL);
		return satf_next_capp_id++;
	}
	return CAPP_INVALID_ID;
}

resetCapturePoints() {
	for(new i = 0; i < satf_next_capp_id; i++) {
		satf_capp_int[i][CAPP_OWNER] = TEAM_NEUTRAL;
		if(satf_capp_int[i][CAPP_TEAM_BASE] == TEAM_ALPHA) {
			satf_capp_int[i][CAPP_STATUS] = satf_capp_int[i][CAPP_STATUS_LIMIT];
		} else if(satf_capp_int[i][CAPP_TEAM_BASE] == TEAM_BETA) {
			satf_capp_int[i][CAPP_STATUS] = -satf_capp_int[i][CAPP_STATUS_LIMIT];
		} else {
			satf_capp_int[i][CAPP_STATUS] = 0;
		}
		updateCapturePointOwner(i);
	}
}

deleteCapturePoints() {
	for(new i = 0; i < satf_next_capp_id; i++) {
		satf_capp_links_index[i] = 0;
		DestroyObject(satf_capp_int[i][CAPP_OBJECT]);
		for(new j = 0; j < maxPlayers; j++) {
			if(IsPlayerConnected(j)) RemovePlayerMapIcon(j, i+CAPP_ICON_OFFSET);
		}
	}
	satf_next_capp_id = 0;
}

createLink(linkid1, linkid2) {
	if(linkid1 == linkid2 || linkid1 == CAPP_INVALID_ID || linkid2 == CAPP_INVALID_ID) return 0;
	satf_capp_links[linkid1][satf_capp_links_index[linkid1]++] = linkid2;
	satf_capp_links[linkid2][satf_capp_links_index[linkid2]++] = linkid1;
	return 1;
}

/*getCapturePointPosition(cappid, &Float:x, &Float:y, &Float:z, &Float:radius) {
	x = satf_capp_float[cappid][CAPP_X];
	y = satf_capp_float[cappid][CAPP_Y];
	z = satf_capp_float[cappid][CAPP_Z];
	radius = satf_capp_float[cappid][CAPP_RADIUS];
}*/

getCapturePointOwner(cappid) {
	return satf_capp_int[cappid][CAPP_OWNER];
}

getCapturePointTeamBase(cappid) {
	return satf_capp_int[cappid][CAPP_TEAM_BASE];
}

getCapturePointStatus(cappid) {
	return satf_capp_int[cappid][CAPP_STATUS];
}

getCapturePointStatusLimit(cappid) {
	return satf_capp_int[cappid][CAPP_STATUS_LIMIT];
}

/*setCapturePointOwner(cappid, teamid) {
	switch(teamid) {
		case TEAM_NEUTRAL: satf_capp_int[cappid][CAPP_STATUS] = 0;
		case TEAM_ALPHA: satf_capp_int[cappid][CAPP_STATUS] = satf_capp_int[cappid][CAPP_STATUS_LIMIT];
		case TEAM_BETA: satf_capp_int[cappid][CAPP_STATUS] = -satf_capp_int[cappid][CAPP_STATUS_LIMIT];
	}
}*/

isPointAccessableForTeam(cappid, teamid) {
	if(satf_capp_int[cappid][CAPP_TEAM_BASE] == teamid) return 0;
	for(new i = 0; i < satf_capp_links_index[cappid]; i++) {
		if(satf_capp_int[satf_capp_links[cappid][i]][CAPP_OWNER] == teamid) return 1;
	}
	//if(satf_capp_int[cappid][CAPP_OWNER] == teamid) return 1;
	return 0;
}

isPointAccessableForPlayer(cappid, playerid) {
	return isPointAccessableForTeam(cappid, satf_players[playerid][PLAYER_TEAM]);
}

isPlayerInRangeOfCapturePoint(playerid, cappid) {
	return (distanceBetweenPoints3d(satf_players_position[playerid][POS_X], satf_players_position[playerid][POS_Y], satf_players_position[playerid][POS_Z], satf_capp_float[cappid][CAPP_X], satf_capp_float[cappid][CAPP_Y], satf_capp_float[cappid][CAPP_Z]) <= satf_capp_float[cappid][CAPP_RADIUS]);
}

increaseScoreCapturePoint(cappid, teamid) {
	if(teamid == TEAM_ALPHA) {
		if(satf_capp_int[cappid][CAPP_STATUS] < satf_capp_int[cappid][CAPP_STATUS_LIMIT]) {
			satf_capp_int[cappid][CAPP_STATUS]++;
			return 1;
		}
	} else if(teamid == TEAM_BETA) {
		if(satf_capp_int[cappid][CAPP_STATUS] > -satf_capp_int[cappid][CAPP_STATUS_LIMIT]) {
			satf_capp_int[cappid][CAPP_STATUS]--;
			return 1;
		}
	}
	return 0;
}

/*increaseScoreCapturePointPlayer(cappid, playerid) {
	if(increaseScoreCapturePoint(cappid, satf_players[playerid][PLAYER_TEAM])) givePlayerXP(playerid, 5);
}*/

updateCapturePointStatus(cappid, player_per_team[]) {
	new change = player_per_team[0]-player_per_team[1];
	if(change == 0) return 0;
	if(change < 3 && change > -3) {
		if((change < 0 && -satf_capp_int[cappid][CAPP_STATUS] < satf_capp_int[cappid][CAPP_STATUS_LIMIT]) || (change > 0 && satf_capp_int[cappid][CAPP_STATUS] < satf_capp_int[cappid][CAPP_STATUS_LIMIT])) {
				satf_capp_int[cappid][CAPP_STATUS] += change;
				return change;
		}
	}
	if(change < -3 && -satf_capp_int[cappid][CAPP_STATUS] < satf_capp_int[cappid][CAPP_STATUS_LIMIT]) {
		satf_capp_int[cappid][CAPP_STATUS] -= 3;
		return -3;
	}
	if(change > 3 && satf_capp_int[cappid][CAPP_STATUS] < satf_capp_int[cappid][CAPP_STATUS_LIMIT]) {
		satf_capp_int[cappid][CAPP_STATUS] += 3;
		return 3;
	}
	return 0;
}

updateCapturePointOwner(cappid) {
	if(satf_capp_int[cappid][CAPP_TEAM_BASE] == TEAM_NEUTRAL && ((satf_capp_int[cappid][CAPP_STATUS] != 0 && satf_capp_int[cappid][CAPP_OWNER] == TEAM_NEUTRAL) || satf_capp_int[cappid][CAPP_OWNER] != TEAM_NEUTRAL)) {
		new hasAlivePeers;
		for(new i = 0; i < satf_capp_links_index[cappid]; i++) {
			if(satf_capp_int[satf_capp_links[cappid][i]][CAPP_OWNER] == satf_capp_int[cappid][CAPP_OWNER] || (satf_capp_int[cappid][CAPP_STATUS] > 0 && satf_capp_int[satf_capp_links[cappid][i]][CAPP_OWNER] == TEAM_ALPHA) || (satf_capp_int[cappid][CAPP_STATUS] < 0 && satf_capp_int[satf_capp_links[cappid][i]][CAPP_OWNER] == TEAM_BETA)) {
				hasAlivePeers = true;
				break;
			}
		}
		if(!hasAlivePeers) {
			if(satf_capp_int[cappid][CAPP_STATUS] < 0) {
				satf_capp_int[cappid][CAPP_STATUS]++;
			} else if(satf_capp_int[cappid][CAPP_STATUS] > 0) {
				satf_capp_int[cappid][CAPP_STATUS]--;
			}
		}
	}
	if(satf_capp_int[cappid][CAPP_TEAM_BASE] != TEAM_NEUTRAL && abs(satf_capp_int[cappid][CAPP_STATUS]) < satf_capp_int[cappid][CAPP_STATUS_LIMIT]) {
		new hasEnemyPeers;
		for(new i = 0; i < satf_capp_links_index[cappid]; i++) {
			if(satf_capp_int[satf_capp_links[cappid][i]][CAPP_OWNER] != TEAM_NEUTRAL && satf_capp_int[satf_capp_links[cappid][i]][CAPP_OWNER] != satf_capp_int[cappid][CAPP_TEAM_BASE]) {
				hasEnemyPeers = true;
				break;
			}
		}
		if(!hasEnemyPeers) {
			increaseScoreCapturePoint(cappid, satf_capp_int[cappid][CAPP_TEAM_BASE]);
		}
	}
	if(satf_capp_int[cappid][CAPP_STATUS] == 0 && satf_capp_int[cappid][CAPP_TEAM_BASE] == TEAM_NEUTRAL) {
		if(satf_capp_int[cappid][CAPP_OWNER] == TEAM_ALPHA) {
			SendClientMessageToAll(COLOR_ALPHA, "TEAM ALPHA has lost a node.");
		} else if(satf_capp_int[cappid][CAPP_OWNER] == TEAM_BETA) {
			SendClientMessageToAll(COLOR_BETA, "TEAM BETA has lost a node.");
		}
		satf_capp_int[cappid][CAPP_OWNER] = TEAM_NEUTRAL;
		updateMapIcon(cappid, CAPP_ICON_NEUTRAL);
	} else if(satf_capp_int[cappid][CAPP_STATUS] >= satf_capp_int[cappid][CAPP_STATUS_LIMIT] || (satf_capp_int[cappid][CAPP_STATUS] >= 0 && satf_capp_int[cappid][CAPP_TEAM_BASE] == TEAM_BETA)) {
		if(satf_capp_int[cappid][CAPP_OWNER] != TEAM_ALPHA && satf_capp_int[cappid][CAPP_TEAM_BASE] != TEAM_ALPHA) {
			SendClientMessageToAll(COLOR_ALPHA, "TEAM ALPHA has captured a node.");
		}
		satf_capp_int[cappid][CAPP_STATUS] = satf_capp_int[cappid][CAPP_STATUS_LIMIT];
		satf_capp_int[cappid][CAPP_OWNER] = TEAM_ALPHA;
		updateMapIcon(cappid, CAPP_ICON_ALPHA);
		if(satf_capp_int[cappid][CAPP_TEAM_BASE] == TEAM_BETA) {
			endRound(TEAM_ALPHA, cappid);
		}
	} else if(satf_capp_int[cappid][CAPP_STATUS] <= -satf_capp_int[cappid][CAPP_STATUS_LIMIT] || (satf_capp_int[cappid][CAPP_STATUS] <= 0 && satf_capp_int[cappid][CAPP_TEAM_BASE] == TEAM_ALPHA)) {
		if(satf_capp_int[cappid][CAPP_OWNER] != TEAM_BETA && satf_capp_int[cappid][CAPP_TEAM_BASE] != TEAM_BETA) {
			SendClientMessageToAll(COLOR_BETA, "TEAM BETA has captured a node.");
		}
		satf_capp_int[cappid][CAPP_STATUS] = -satf_capp_int[cappid][CAPP_STATUS_LIMIT];
		satf_capp_int[cappid][CAPP_OWNER] = TEAM_BETA;
		updateMapIcon(cappid, CAPP_ICON_BETA);
		if(satf_capp_int[cappid][CAPP_TEAM_BASE] == TEAM_ALPHA) {
			endRound(TEAM_BETA, cappid);
		}
	}
}

updateMapIcon(cappid, iconid) {
	if(satf_capp_int[cappid][CAPP_OBJECT_ID] != CAPP_OBJECT_NEUTRAL && satf_capp_int[cappid][CAPP_OWNER] == TEAM_NEUTRAL) {
		DestroyObject(satf_capp_int[cappid][CAPP_OBJECT]);
		satf_capp_int[cappid][CAPP_OBJECT] = CreateObject(CAPP_OBJECT_NEUTRAL,satf_capp_float[cappid][CAPP_X],satf_capp_float[cappid][CAPP_Y],satf_capp_float[cappid][CAPP_Z],0,0,0);
		satf_capp_int[cappid][CAPP_OBJECT_ID] = CAPP_OBJECT_NEUTRAL;
	} else if(satf_capp_int[cappid][CAPP_OBJECT_ID] == CAPP_OBJECT_NEUTRAL && satf_capp_int[cappid][CAPP_OWNER] != TEAM_NEUTRAL) {
		DestroyObject(satf_capp_int[cappid][CAPP_OBJECT]);
		satf_capp_int[cappid][CAPP_OBJECT] = CreateObject(CAPP_OBJECT_CAPTURED,satf_capp_float[cappid][CAPP_X],satf_capp_float[cappid][CAPP_Y],satf_capp_float[cappid][CAPP_Z],0,0,0);
		satf_capp_int[cappid][CAPP_OBJECT_ID] = CAPP_OBJECT_CAPTURED;
	}
	for(new i = 0; i < MAX_PLAYERS; i++) {
		if(satf_players[i][PLAYER_CLASS] != CLASS_NOT_CONNECTED && (isPointAccessableForPlayer(cappid, i) || satf_capp_int[cappid][CAPP_TEAM_BASE] == satf_players[i][PLAYER_TEAM])) {
			SetPlayerMapIcon(i,cappid+CAPP_ICON_OFFSET,satf_capp_float[cappid][CAPP_X],satf_capp_float[cappid][CAPP_Y],satf_capp_float[cappid][CAPP_Z],iconid,0xFFFFFFFF);
		} else {
			RemovePlayerMapIcon(i, cappid+CAPP_ICON_OFFSET);
		}
	}
}

cappStatusString(capp_status[][], size, cappid) {
	if(satf_capp_int[cappid][CAPP_TEAM_BASE] == TEAM_NEUTRAL) {
			if(abs(getCapturePointStatusLimit(cappid)-getCapturePointStatus(cappid)) == 0) {
				format(capp_status[TEAM_ALPHA], size, "%s%s", satf_team_colors_gt[getCapturePointOwner(cappid)], satf_team_names[getCapturePointOwner(cappid)]);
			} else {
				format(capp_status[TEAM_ALPHA], size, "%s%s %d", satf_team_colors_gt[getCapturePointOwner(cappid)], satf_team_names[getCapturePointOwner(cappid)], abs(getCapturePointStatusLimit(cappid)-getCapturePointStatus(cappid)));
			}
			if(abs((-getCapturePointStatusLimit(cappid))-getCapturePointStatus(cappid)) == 0) {
				format(capp_status[TEAM_BETA], size, "%s%s", satf_team_colors_gt[getCapturePointOwner(cappid)], satf_team_names[getCapturePointOwner(cappid)]);
			} else {
				format(capp_status[TEAM_BETA], size, "%s%s %d", satf_team_colors_gt[getCapturePointOwner(cappid)], satf_team_names[getCapturePointOwner(cappid)], abs((-getCapturePointStatusLimit(cappid))-getCapturePointStatus(cappid)));
			}
		} else {
			if(abs(getCapturePointStatus(cappid)) == 0) {
				format(capp_status[TEAM_ALPHA], size, "%s%s BASE", satf_team_colors_gt[getCapturePointTeamBase(cappid)], satf_team_names[getCapturePointTeamBase(cappid)]);
				format(capp_status[TEAM_BETA], size, "%s%s BASE", satf_team_colors_gt[getCapturePointTeamBase(cappid)], satf_team_names[getCapturePointTeamBase(cappid)]);
			} else {
				format(capp_status[TEAM_ALPHA], size, "%s%s BASE %d", satf_team_colors_gt[getCapturePointTeamBase(cappid)], satf_team_names[getCapturePointTeamBase(cappid)], abs(getCapturePointStatus(cappid)));
				format(capp_status[TEAM_BETA], size, "%s%s BASE %d", satf_team_colors_gt[getCapturePointTeamBase(cappid)], satf_team_names[getCapturePointTeamBase(cappid)], abs(getCapturePointStatus(cappid)));
			}
		}
}

new playersInRangeOfPoint[MAX_CAPPS][MAX_PLAYERS], playersInRangeOfPointIndex[MAX_CAPPS];
capturePointTimer() {
	new capp_status[2][32];
	new player_per_team[2];
	new change,team;
	for(new i = 0; i < satf_next_capp_id; i++) {
		cappStatusString(capp_status, sizeof(capp_status[]), i);
		playersInRangeOfPointIndex[i] = 0;
		player_per_team[0] = 0;
		player_per_team[1] = 0;
		for(new j = 0; j < maxPlayers; j++) {
			if(satf_players[j][PLAYER_CLASS] != CLASS_NOT_CONNECTED) {
				if(isPlayerInRangeOfCapturePoint(j, i) && playerAlive[j]) {
					if(IsPlayerInAnyVehicle(j)) {
						if(satf_capp_int[i][CAPP_OWNER] != satf_players[j][PLAYER_TEAM] && isPointAccessableForPlayer(i, j)) {
							TextDrawShowForPlayer(j, insideVehicle);
						} else if(!isPointAccessableForPlayer(i, j) && satf_capp_int[i][CAPP_TEAM_BASE] != satf_players[j][PLAYER_TEAM]) {
							TextDrawShowForPlayer(j, nodeNotAccessable);
						}
						GameTextForPlayer(j, capp_status[satf_players[j][PLAYER_TEAM]], 1100, 4);
					} else if(isPointAccessableForPlayer(i, j)) {
						playersInRangeOfPoint[i][playersInRangeOfPointIndex[i]] = j;
						playersInRangeOfPointIndex[i]++;
						//increaseScoreCapturePointPlayer(i, j);
						player_per_team[satf_players[j][PLAYER_TEAM]]++;
					} else {
						if(satf_capp_int[i][CAPP_TEAM_BASE] != satf_players[j][PLAYER_TEAM]) TextDrawShowForPlayer(j, nodeNotAccessable);
						GameTextForPlayer(j, capp_status[satf_players[j][PLAYER_TEAM]], 1100, 4);
					}
				}
			}
		}
		change = updateCapturePointStatus(i, player_per_team);
		if(change < 0) team = TEAM_BETA; else if(change > 0) team = TEAM_ALPHA; else team = TEAM_NEUTRAL;
		updateCapturePointOwner(i);
		cappStatusString(capp_status, sizeof(capp_status[]), i);
		for(new j = 0; j < playersInRangeOfPointIndex[i]; j++) {
			GameTextForPlayer(playersInRangeOfPoint[i][j], capp_status[satf_players[playersInRangeOfPoint[i][j]][PLAYER_TEAM]], 1100, 4);
			if(satf_players[playersInRangeOfPoint[i][j]][PLAYER_TEAM] == team) givePlayerXP(playersInRangeOfPoint[i][j], 3);
		}
	}
}
