/*  Team Fortress San Andreas Map Funktions
 *
 *  (c) Copyright 2007, teh 1337 h4xx0r crew
 *
 */

#if defined _satf_loadmap_included
	#endinput
#endif
#define _satf_loadmap_included

#include <a_samp>
#include <satf_maps>
#include <satf_capturepoints>
#include <satf_world>

#define MAP_FEXT ".tfm"

#define MAX_STATES 77
#define MAX_INPUT 19

#define STATE_ERROR 0
#define STATE_START 1

#define STATE_SPAWNS 2
#define STATE_SPAWNS_TEAM 3
#define STATE_SPAWNS_X_N 4
#define STATE_SPAWNS_X 5
#define STATE_SPAWNS_X_D 6
#define STATE_SPAWNS_Y_N 7
#define STATE_SPAWNS_Y 8
#define STATE_SPAWNS_Y_D 9
#define STATE_SPAWNS_Z_N 10
#define STATE_SPAWNS_Z 11
#define STATE_SPAWNS_Z_D 12
#define STATE_SPAWNS_A 13
#define STATE_SPAWNS_A_D 14

#define STATE_NODES 15
#define STATE_NODES_TEAM 16
#define STATE_NODES_HP_N 17
#define STATE_NODES_HP 18
#define STATE_NODES_MAXHP 19
#define STATE_NODES_X_N 20
#define STATE_NODES_X 21
#define STATE_NODES_X_D 22
#define STATE_NODES_Y_N 23
#define STATE_NODES_Y 24
#define STATE_NODES_Y_D 25
#define STATE_NODES_Z_N 26
#define STATE_NODES_Z 27
#define STATE_NODES_Z_D 28
#define STATE_NODES_R 29
#define STATE_NODES_R_D 30

#define STATE_LINKS 31
#define STATE_LINKS_LINK1 32
#define STATE_LINKS_LINK2 33

#define STATE_VEHICLES 34
#define STATE_VEHICLES_MODEL 35
#define STATE_VEHICLES_COLOR1 36
#define STATE_VEHICLES_COLOR2 37
#define STATE_VEHICLES_RESPAWNTIME 38
#define STATE_VEHICLES_X_N 39
#define STATE_VEHICLES_X 40
#define STATE_VEHICLES_X_D 41
#define STATE_VEHICLES_Y_N 42
#define STATE_VEHICLES_Y 43
#define STATE_VEHICLES_Y_D 44
#define STATE_VEHICLES_Z_N 45
#define STATE_VEHICLES_Z 46
#define STATE_VEHICLES_Z_D 47
#define STATE_VEHICLES_A 48
#define STATE_VEHICLES_A_D 49

#define STATE_BOUNDARIES 50
#define STATE_BOUNDARIES_MINX_N 51
#define STATE_BOUNDARIES_MINX 52
#define STATE_BOUNDARIES_MINX_D 53
#define STATE_BOUNDARIES_MAXX_N 54
#define STATE_BOUNDARIES_MAXX 55
#define STATE_BOUNDARIES_MAXX_D 56
#define STATE_BOUNDARIES_MINY_N 57
#define STATE_BOUNDARIES_MINY 58
#define STATE_BOUNDARIES_MINY_D 59
#define STATE_BOUNDARIES_MAXY_N 60
#define STATE_BOUNDARIES_MAXY 61
#define STATE_BOUNDARIES_MAXY_D 62

#define STATE_AIRBORNE 63
#define STATE_AIRBORNE_X_N 64
#define STATE_AIRBORNE_X 65
#define STATE_AIRBORNE_X_D 66
#define STATE_AIRBORNE_Y_N 67
#define STATE_AIRBORNE_Y 68
#define STATE_AIRBORNE_Y_D 69
#define STATE_AIRBORNE_Z_N 70
#define STATE_AIRBORNE_Z 71
#define STATE_AIRBORNE_Z_D 72

#define STATE_TIME 73
#define STATE_TIME_NUMBER 74

#define STATE_WEATHER 75
#define STATE_WEATHER_NUMBER 76

new parser_state = STATE_START;

new const parser_transition_table[MAX_STATES][MAX_INPUT] = {
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}, //STATE_ERROR
{0,0,0,0,0,STATE_SPAWNS,STATE_NODES,STATE_LINKS,STATE_VEHICLES,STATE_BOUNDARIES,STATE_AIRBORNE,0,0,0,0,STATE_START,0,STATE_TIME,STATE_WEATHER}, //STATE_START
{0,STATE_SPAWNS_TEAM,STATE_SPAWNS_TEAM,0,0,0,STATE_NODES,STATE_LINKS,STATE_VEHICLES,STATE_BOUNDARIES,STATE_AIRBORNE,0,0,STATE_SPAWNS,STATE_SPAWNS,STATE_SPAWNS,0,STATE_TIME,STATE_WEATHER}, //STATE_SPAWNS
{0,0,0,0,0,0,0,0,0,0,0,STATE_SPAWNS_X_N,0,0,0,STATE_SPAWNS_TEAM,0,0,0}, //STATE_SPAWNS_TEAM
{0,STATE_SPAWNS_X,STATE_SPAWNS_X,STATE_SPAWNS_X,STATE_SPAWNS_X,0,0,0,0,0,0,0,0,0,0,STATE_SPAWNS_X_N,STATE_SPAWNS_X,0,0}, //STATE_SPAWNS_X_N
{0,STATE_SPAWNS_X,STATE_SPAWNS_X,STATE_SPAWNS_X,STATE_SPAWNS_X,0,0,0,0,0,0,0,STATE_SPAWNS_X_D,0,0,STATE_SPAWNS_X,0,0,0}, //STATE_SPAWNS_X
{0,STATE_SPAWNS_X_D,STATE_SPAWNS_X_D,STATE_SPAWNS_X_D,STATE_SPAWNS_X_D,0,0,0,0,0,0,STATE_SPAWNS_Y_N,0,0,0,STATE_SPAWNS_X_D,0,0,0}, //STATE_SPAWNS_X_D
{0,STATE_SPAWNS_Y,STATE_SPAWNS_Y,STATE_SPAWNS_Y,STATE_SPAWNS_Y,0,0,0,0,0,0,0,0,0,0,STATE_SPAWNS_Y_N,STATE_SPAWNS_Y,0,0}, //STATE_SPAWNS_Y_N
{0,STATE_SPAWNS_Y,STATE_SPAWNS_Y,STATE_SPAWNS_Y,STATE_SPAWNS_Y,0,0,0,0,0,0,0,STATE_SPAWNS_Y_D,0,0,STATE_SPAWNS_Y,0,0,0}, //STATE_SPAWNS_Y
{0,STATE_SPAWNS_Y_D,STATE_SPAWNS_Y_D,STATE_SPAWNS_Y_D,STATE_SPAWNS_Y_D,0,0,0,0,0,0,STATE_SPAWNS_Z_N,0,0,0,STATE_SPAWNS_Y_D,0,0,0}, //STATE_SPAWNS_Y_D
{0,STATE_SPAWNS_Z,STATE_SPAWNS_Z,STATE_SPAWNS_Z,STATE_SPAWNS_Z,0,0,0,0,0,0,0,0,0,0,STATE_SPAWNS_Z_N,STATE_SPAWNS_Z,0,0}, //STATE_SPAWNS_Z_N
{0,STATE_SPAWNS_Z,STATE_SPAWNS_Z,STATE_SPAWNS_Z,STATE_SPAWNS_Z,0,0,0,0,0,0,0,STATE_SPAWNS_Z_D,0,0,STATE_SPAWNS_Z,0,0,0}, //STATE_SPAWNS_Z
{0,STATE_SPAWNS_Z_D,STATE_SPAWNS_Z_D,STATE_SPAWNS_Z_D,STATE_SPAWNS_Z_D,0,0,0,0,0,0,STATE_SPAWNS_A,0,0,0,STATE_SPAWNS_Z_D,0,0,0}, //STATE_SPAWNS_Z_D
{0,STATE_SPAWNS_A,STATE_SPAWNS_A,STATE_SPAWNS_A,STATE_SPAWNS_A,0,0,0,0,0,0,0,STATE_SPAWNS_A_D,0,0,STATE_SPAWNS_A,0,0,0}, //STATE_SPAWNS_A
{0,STATE_SPAWNS_A_D,STATE_SPAWNS_A_D,STATE_SPAWNS_A_D,STATE_SPAWNS_A_D,0,0,0,0,0,0,0,0,STATE_SPAWNS,STATE_SPAWNS,STATE_SPAWNS_A_D,0,0,0}, //STATE_SPAWNS_A_D
{0,STATE_NODES_TEAM,STATE_NODES_TEAM,STATE_NODES_TEAM,0,STATE_SPAWNS,0,STATE_LINKS,STATE_VEHICLES,STATE_BOUNDARIES,STATE_AIRBORNE,0,0,STATE_NODES,STATE_NODES,STATE_NODES,0,STATE_TIME,STATE_WEATHER}, //STATE_NODES
{0,0,0,0,0,0,0,0,0,0,0,STATE_NODES_HP_N,0,0,0,STATE_NODES_TEAM,0,0,0}, //STATE_NODES_TEAM
{0,STATE_NODES_HP,STATE_NODES_HP,STATE_NODES_HP,STATE_NODES_HP,0,0,0,0,0,0,0,0,0,0,STATE_NODES_HP_N,STATE_NODES_HP,0,0}, //STATE_NODES_HP_N
{0,STATE_NODES_HP,STATE_NODES_HP,STATE_NODES_HP,STATE_NODES_HP,0,0,0,0,0,0,STATE_NODES_MAXHP,0,0,0,STATE_NODES_HP,0,0,0}, //STATE_NODES_HP
{0,STATE_NODES_MAXHP,STATE_NODES_MAXHP,STATE_NODES_MAXHP,STATE_NODES_MAXHP,0,0,0,0,0,0,STATE_NODES_X_N,0,0,0,STATE_NODES_MAXHP,0,0,0}, //STATE_NODES_MAXHP
{0,STATE_NODES_X,STATE_NODES_X,STATE_NODES_X,STATE_NODES_X,0,0,0,0,0,0,0,0,0,0,STATE_NODES_X_N,STATE_NODES_X,0,0}, //STATE_NODES_X_N
{0,STATE_NODES_X,STATE_NODES_X,STATE_NODES_X,STATE_NODES_X,0,0,0,0,0,0,0,STATE_NODES_X_D,0,0,STATE_NODES_X,0,0,0}, //STATE_NODES_X
{0,STATE_NODES_X_D,STATE_NODES_X_D,STATE_NODES_X_D,STATE_NODES_X_D,0,0,0,0,0,0,STATE_NODES_Y_N,0,0,0,STATE_NODES_X_D,0,0,0}, //STATE_NODES_X_D
{0,STATE_NODES_Y,STATE_NODES_Y,STATE_NODES_Y,STATE_NODES_Y,0,0,0,0,0,0,0,0,0,0,STATE_NODES_Y_N,STATE_NODES_Y,0,0}, //STATE_NODES_Y_N
{0,STATE_NODES_Y,STATE_NODES_Y,STATE_NODES_Y,STATE_NODES_Y,0,0,0,0,0,0,0,STATE_NODES_Y_D,0,0,STATE_NODES_Y,0,0,0}, //STATE_NODES_Y
{0,STATE_NODES_Y_D,STATE_NODES_Y_D,STATE_NODES_Y_D,STATE_NODES_Y_D,0,0,0,0,0,0,STATE_NODES_Z_N,0,0,0,STATE_NODES_Y_D,0,0,0}, //STATE_NODES_Y_D
{0,STATE_NODES_Z,STATE_NODES_Z,STATE_NODES_Z,STATE_NODES_Z,0,0,0,0,0,0,0,0,0,0,STATE_NODES_Z_N,STATE_NODES_Z,0,0}, //STATE_NODES_Z_N
{0,STATE_NODES_Z,STATE_NODES_Z,STATE_NODES_Z,STATE_NODES_Z,0,0,0,0,0,0,0,STATE_NODES_Z_D,0,0,STATE_NODES_Z,0,0,0}, //STATE_NODES_Z
{0,STATE_NODES_Z_D,STATE_NODES_Z_D,STATE_NODES_Z_D,STATE_NODES_Z_D,0,0,0,0,0,0,STATE_NODES_R,0,0,0,STATE_NODES_Z_D,0,0,0}, //STATE_NODES_Z_D
{0,STATE_NODES_R,STATE_NODES_R,STATE_NODES_R,STATE_NODES_R,0,0,0,0,0,0,0,STATE_NODES_R_D,0,0,STATE_NODES_R,0,0,0}, //STATE_NODES_R
{0,STATE_NODES_R_D,STATE_NODES_R_D,STATE_NODES_R_D,STATE_NODES_R_D,0,0,0,0,0,0,0,0,STATE_NODES,STATE_NODES,STATE_NODES_R_D,0,0,0}, //STATE_NODES_R_D
{0,STATE_LINKS_LINK1,STATE_LINKS_LINK1,STATE_LINKS_LINK1,STATE_LINKS_LINK1,STATE_SPAWNS,STATE_NODES,0,STATE_VEHICLES,STATE_BOUNDARIES,STATE_AIRBORNE,0,0,STATE_LINKS,STATE_LINKS,STATE_LINKS,0,STATE_TIME,STATE_WEATHER}, //STATE_LINKS
{0,STATE_LINKS_LINK1,STATE_LINKS_LINK1,STATE_LINKS_LINK1,STATE_LINKS_LINK1,0,0,0,0,0,0,STATE_LINKS_LINK2,0,0,0,STATE_LINKS_LINK1,0,0,0}, //STATE_LINKS_LINK1
{0,STATE_LINKS_LINK2,STATE_LINKS_LINK2,STATE_LINKS_LINK2,STATE_LINKS_LINK2,0,0,0,0,0,0,0,0,STATE_LINKS,STATE_LINKS,STATE_LINKS_LINK2,0,0,0}, //STATE_LINKS_LINK2
{0,STATE_VEHICLES_MODEL,STATE_VEHICLES_MODEL,STATE_VEHICLES_MODEL,STATE_VEHICLES_MODEL,STATE_SPAWNS,STATE_NODES,STATE_LINKS,0,STATE_BOUNDARIES,STATE_AIRBORNE,0,0,STATE_VEHICLES,STATE_VEHICLES,STATE_VEHICLES,0,STATE_TIME,STATE_WEATHER}, //STATE_VEHICLES
{0,STATE_VEHICLES_MODEL,STATE_VEHICLES_MODEL,STATE_VEHICLES_MODEL,STATE_VEHICLES_MODEL,0,0,0,0,0,0,STATE_VEHICLES_COLOR1,0,0,0,STATE_VEHICLES_MODEL,0,0,0}, //STATE_VEHICLES_MODEL
{0,STATE_VEHICLES_COLOR1,STATE_VEHICLES_COLOR1,STATE_VEHICLES_COLOR1,STATE_VEHICLES_COLOR1,0,0,0,0,0,0,STATE_VEHICLES_COLOR2,0,0,0,STATE_VEHICLES_COLOR1,0,0,0}, //STATE_VEHICLES_COLOR1
{0,STATE_VEHICLES_COLOR2,STATE_VEHICLES_COLOR2,STATE_VEHICLES_COLOR2,STATE_VEHICLES_COLOR2,0,0,0,0,0,0,STATE_VEHICLES_RESPAWNTIME,0,0,0,STATE_VEHICLES_COLOR2,0,0,0}, //STATE_VEHICLES_COLOR2
{0,STATE_VEHICLES_RESPAWNTIME,STATE_VEHICLES_RESPAWNTIME,STATE_VEHICLES_RESPAWNTIME,STATE_VEHICLES_RESPAWNTIME,0,0,0,0,0,0,STATE_VEHICLES_X_N,0,0,0,STATE_VEHICLES_RESPAWNTIME,0,0,0}, //STATE_VEHICLES_RESPAWNTIME
{0,STATE_VEHICLES_X,STATE_VEHICLES_X,STATE_VEHICLES_X,STATE_VEHICLES_X,0,0,0,0,0,0,0,0,0,0,STATE_VEHICLES_X_N,STATE_VEHICLES_X,0,0}, //STATE_VEHICLES_X_N
{0,STATE_VEHICLES_X,STATE_VEHICLES_X,STATE_VEHICLES_X,STATE_VEHICLES_X,0,0,0,0,0,0,0,STATE_VEHICLES_X_D,0,0,STATE_VEHICLES_X,0,0,0}, //STATE_VEHICLES_X
{0,STATE_VEHICLES_X_D,STATE_VEHICLES_X_D,STATE_VEHICLES_X_D,STATE_VEHICLES_X_D,0,0,0,0,0,0,STATE_VEHICLES_Y_N,0,0,0,STATE_VEHICLES_X_D,0,0,0}, //STATE_VEHICLES_X_D
{0,STATE_VEHICLES_Y,STATE_VEHICLES_Y,STATE_VEHICLES_Y,STATE_VEHICLES_Y,0,0,0,0,0,0,0,0,0,0,STATE_VEHICLES_Y_N,STATE_VEHICLES_Y,0,0}, //STATE_VEHICLES_Y_N
{0,STATE_VEHICLES_Y,STATE_VEHICLES_Y,STATE_VEHICLES_Y,STATE_VEHICLES_Y,0,0,0,0,0,0,0,STATE_VEHICLES_Y_D,0,0,STATE_VEHICLES_Y,0,0,0}, //STATE_VEHICLES_Y
{0,STATE_VEHICLES_Y_D,STATE_VEHICLES_Y_D,STATE_VEHICLES_Y_D,STATE_VEHICLES_Y_D,0,0,0,0,0,0,STATE_VEHICLES_Z_N,0,0,0,STATE_VEHICLES_Y_D,0,0,0}, //STATE_VEHICLES_Y_D
{0,STATE_VEHICLES_Z,STATE_VEHICLES_Z,STATE_VEHICLES_Z,STATE_VEHICLES_Z,0,0,0,0,0,0,0,0,0,0,STATE_VEHICLES_Z_N,STATE_VEHICLES_Z,0,0}, //STATE_VEHICLES_Z_N
{0,STATE_VEHICLES_Z,STATE_VEHICLES_Z,STATE_VEHICLES_Z,STATE_VEHICLES_Z,0,0,0,0,0,0,0,STATE_VEHICLES_Z_D,0,0,STATE_VEHICLES_Z,0,0,0}, //STATE_VEHICLES_Z
{0,STATE_VEHICLES_Z_D,STATE_VEHICLES_Z_D,STATE_VEHICLES_Z_D,STATE_VEHICLES_Z_D,0,0,0,0,0,0,STATE_VEHICLES_A,0,0,0,STATE_VEHICLES_Z_D,0,0,0}, //STATE_VEHICLES_Z_D
{0,STATE_VEHICLES_A,STATE_VEHICLES_A,STATE_VEHICLES_A,STATE_VEHICLES_A,0,0,0,0,0,0,0,STATE_VEHICLES_A_D,0,0,STATE_VEHICLES_A,0,0,0}, //STATE_VEHICLES_A
{0,STATE_VEHICLES_A_D,STATE_VEHICLES_A_D,STATE_VEHICLES_A_D,STATE_VEHICLES_A_D,0,0,0,0,0,0,0,0,STATE_VEHICLES,STATE_VEHICLES,STATE_VEHICLES_A_D,0,0,0}, //STATE_VEHICLES_A_D
{0,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,STATE_SPAWNS,STATE_NODES,STATE_LINKS,STATE_VEHICLES,0,STATE_AIRBORNE,0,0,STATE_BOUNDARIES,STATE_BOUNDARIES,STATE_BOUNDARIES,STATE_BOUNDARIES_MINX_N,STATE_TIME,STATE_WEATHER}, //STATE_BOUNDARIES
{0,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,0,0,0,0,0,0,0,0,0,0,STATE_BOUNDARIES_MINX_N,STATE_BOUNDARIES_MINX,0,0}, //STATE_BOUNDARIES_MINX_N
{0,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,STATE_BOUNDARIES_MINX,0,0,0,0,0,0,0,STATE_BOUNDARIES_MINX_D,0,0,STATE_BOUNDARIES_MINX,0,0,0}, //STATE_BOUNDARIES_MINX
{0,STATE_BOUNDARIES_MINX_D,STATE_BOUNDARIES_MINX_D,STATE_BOUNDARIES_MINX_D,STATE_BOUNDARIES_MINX_D,0,0,0,0,0,0,STATE_BOUNDARIES_MAXX_N,0,0,0,STATE_BOUNDARIES_MINX_D,0,0,0}, //STATE_BOUNDARIES_MINX_D
{0,STATE_BOUNDARIES_MAXX,STATE_BOUNDARIES_MAXX,STATE_BOUNDARIES_MAXX,STATE_BOUNDARIES_MAXX,0,0,0,0,0,0,0,0,0,0,STATE_BOUNDARIES_MAXX_N,STATE_BOUNDARIES_MAXX,0,0}, //STATE_BOUNDARIES_MAXX_N
{0,STATE_BOUNDARIES_MAXX,STATE_BOUNDARIES_MAXX,STATE_BOUNDARIES_MAXX,STATE_BOUNDARIES_MAXX,0,0,0,0,0,0,0,STATE_BOUNDARIES_MAXX_D,0,0,STATE_BOUNDARIES_MAXX,0,0,0}, //STATE_BOUNDARIES_MAXX
{0,STATE_BOUNDARIES_MAXX_D,STATE_BOUNDARIES_MAXX_D,STATE_BOUNDARIES_MAXX_D,STATE_BOUNDARIES_MAXX_D,0,0,0,0,0,0,STATE_BOUNDARIES_MINY_N,0,0,0,STATE_BOUNDARIES_MAXX_D,0,0,0}, //STATE_BOUNDARIES_MAXX_D
{0,STATE_BOUNDARIES_MINY,STATE_BOUNDARIES_MINY,STATE_BOUNDARIES_MINY,STATE_BOUNDARIES_MINY,0,0,0,0,0,0,0,0,0,0,STATE_BOUNDARIES_MINY_N,STATE_BOUNDARIES_MINY,0,0}, //STATE_BOUNDARIES_MINY_N
{0,STATE_BOUNDARIES_MINY,STATE_BOUNDARIES_MINY,STATE_BOUNDARIES_MINY,STATE_BOUNDARIES_MINY,0,0,0,0,0,0,0,STATE_BOUNDARIES_MINY_D,0,0,STATE_BOUNDARIES_MINY,0,0,0}, //STATE_BOUNDARIES_MINY
{0,STATE_BOUNDARIES_MINY_D,STATE_BOUNDARIES_MINY_D,STATE_BOUNDARIES_MINY_D,STATE_BOUNDARIES_MINY_D,0,0,0,0,0,0,STATE_BOUNDARIES_MAXY_N,0,0,0,STATE_BOUNDARIES_MINY_D,0,0,0}, //STATE_BOUNDARIES_MINY_D
{0,STATE_BOUNDARIES_MAXY,STATE_BOUNDARIES_MAXY,STATE_BOUNDARIES_MAXY,STATE_BOUNDARIES_MAXY,0,0,0,0,0,0,0,0,0,0,STATE_BOUNDARIES_MAXY_N,STATE_BOUNDARIES_MAXY,0,0}, //STATE_BOUNDARIES_MAXY_N
{0,STATE_BOUNDARIES_MAXY,STATE_BOUNDARIES_MAXY,STATE_BOUNDARIES_MAXY,STATE_BOUNDARIES_MAXY,0,0,0,0,0,0,0,STATE_BOUNDARIES_MAXY_D,0,0,STATE_BOUNDARIES_MAXY,0,0,0}, //STATE_BOUNDARIES_MAXY
{0,STATE_BOUNDARIES_MAXY_D,STATE_BOUNDARIES_MAXY_D,STATE_BOUNDARIES_MAXY_D,STATE_BOUNDARIES_MAXY_D,0,0,0,0,0,0,0,0,STATE_BOUNDARIES,STATE_BOUNDARIES,STATE_BOUNDARIES_MAXY_D,0,0,0}, //STATE_BOUNDARIES_MAXY_D
{0,STATE_AIRBORNE_X,STATE_AIRBORNE_X,STATE_AIRBORNE_X,STATE_AIRBORNE_X,STATE_SPAWNS,STATE_NODES,STATE_LINKS,STATE_VEHICLES,STATE_BOUNDARIES,0,0,0,STATE_AIRBORNE,STATE_AIRBORNE,STATE_AIRBORNE,STATE_AIRBORNE_X_N,STATE_TIME,STATE_WEATHER}, //STATE_AIRBORNE
{0,STATE_AIRBORNE_X,STATE_AIRBORNE_X,STATE_AIRBORNE_X,STATE_AIRBORNE_X,0,0,0,0,0,0,0,0,0,0,STATE_AIRBORNE_X_N,STATE_AIRBORNE_X,0,0}, //STATE_AIRBORNE_X_N
{0,STATE_AIRBORNE_X,STATE_AIRBORNE_X,STATE_AIRBORNE_X,STATE_AIRBORNE_X,0,0,0,0,0,0,0,STATE_AIRBORNE_X_D,0,0,STATE_AIRBORNE_X,0,0,0}, //STATE_AIRBORNE_X
{0,STATE_AIRBORNE_X_D,STATE_AIRBORNE_X_D,STATE_AIRBORNE_X_D,STATE_AIRBORNE_X_D,0,0,0,0,0,0,STATE_AIRBORNE_Y_N,0,0,0,STATE_AIRBORNE_X_D,0,0,0}, //STATE_AIRBORNE_X_D
{0,STATE_AIRBORNE_Y,STATE_AIRBORNE_Y,STATE_AIRBORNE_Y,STATE_AIRBORNE_Y,0,0,0,0,0,0,0,0,0,0,STATE_AIRBORNE_Y_N,STATE_AIRBORNE_Y,0,0}, //STATE_AIRBORNE_Y_N
{0,STATE_AIRBORNE_Y,STATE_AIRBORNE_Y,STATE_AIRBORNE_Y,STATE_AIRBORNE_Y,0,0,0,0,0,0,0,STATE_AIRBORNE_Y_D,0,0,STATE_AIRBORNE_Y,0,0,0}, //STATE_AIRBORNE_Y
{0,STATE_AIRBORNE_Y_D,STATE_AIRBORNE_Y_D,STATE_AIRBORNE_Y_D,STATE_AIRBORNE_Y_D,0,0,0,0,0,0,STATE_AIRBORNE_Z_N,0,0,0,STATE_AIRBORNE_Y_D,0,0,0}, //STATE_AIRBORNE_Y_D
{0,STATE_AIRBORNE_Z,STATE_AIRBORNE_Z,STATE_AIRBORNE_Z,STATE_AIRBORNE_Z,0,0,0,0,0,0,0,0,0,0,STATE_AIRBORNE_Z_N,STATE_AIRBORNE_Z,0,0}, //STATE_AIRBORNE_Z_N
{0,STATE_AIRBORNE_Z,STATE_AIRBORNE_Z,STATE_AIRBORNE_Z,STATE_AIRBORNE_Z,0,0,0,0,0,0,0,STATE_AIRBORNE_Z_D,0,0,STATE_AIRBORNE_Z,0,0,0}, //STATE_AIRBORNE_Z
{0,STATE_AIRBORNE_Z_D,STATE_AIRBORNE_Z_D,STATE_AIRBORNE_Z_D,STATE_AIRBORNE_Z_D,0,0,0,0,0,0,0,0,STATE_AIRBORNE,STATE_AIRBORNE,STATE_AIRBORNE_Z_D,0,0,0}, //STATE_AIRBORNE_Z_D
{0,STATE_TIME_NUMBER,STATE_TIME_NUMBER,STATE_TIME_NUMBER,STATE_TIME_NUMBER,STATE_SPAWNS,STATE_NODES,STATE_LINKS,STATE_VEHICLES,STATE_BOUNDARIES,STATE_AIRBORNE,0,0,STATE_TIME,STATE_TIME,STATE_TIME,0,0,STATE_WEATHER},
{0,STATE_TIME_NUMBER,STATE_TIME_NUMBER,STATE_TIME_NUMBER,STATE_TIME_NUMBER,0,0,0,0,0,0,0,0,STATE_TIME,STATE_TIME,STATE_TIME_NUMBER,0,0,0},
{0,STATE_WEATHER_NUMBER,STATE_WEATHER_NUMBER,STATE_WEATHER_NUMBER,STATE_WEATHER_NUMBER,STATE_SPAWNS,STATE_NODES,STATE_LINKS,STATE_VEHICLES,STATE_BOUNDARIES,STATE_AIRBORNE,0,0,STATE_WEATHER,STATE_WEATHER,STATE_WEATHER,0,STATE_TIME,0},
{0,STATE_WEATHER_NUMBER,STATE_WEATHER_NUMBER,STATE_WEATHER_NUMBER,STATE_WEATHER_NUMBER,0,0,0,0,0,0,0,0,STATE_WEATHER,STATE_WEATHER,STATE_WEATHER_NUMBER,0,0,0}
};

new const parser_accepted_states[] = {STATE_START,STATE_SPAWNS,STATE_NODES,STATE_LINKS,STATE_VEHICLES,STATE_BOUNDARIES,STATE_AIRBORNE,STATE_TIME,STATE_WEATHER};

#define ASCII_LF 10
#define ASCII_CR 13
#define ASCII_0 48
#define ASCII_1 49
#define ASCII_2 50
#define ASCII_3 51
#define ASCII_4 52
#define ASCII_5 53
#define ASCII_6 54
#define ASCII_7 55
#define ASCII_8 56
#define ASCII_9 57
#define ASCII_s 115
#define ASCII_S 83
#define ASCII_n 110
#define ASCII_N 78
#define ASCII_l 108
#define ASCII_L 76
#define ASCII_v 118
#define ASCII_V 86
#define ASCII_b 98
#define ASCII_B 66
#define ASCII_A 65
#define ASCII_a 97
#define ASCII_COLON 44
#define ASCII_DOT 46
#define ASCII_SP 32
#define ASCII_MINUS 45
#define ASCII_T 84
#define ASCII_t 116
#define ASCII_W 87
#define ASCII_w 119

translateChar(chara) {
	switch(chara) {
		case ASCII_0: return 1;
		case ASCII_1: return 2;
		case ASCII_2: return 3;
		case ASCII_3..ASCII_9: return 4;
		case ASCII_s: return 5;
		case ASCII_S: return 5;
		case ASCII_n: return 6;
		case ASCII_N: return 6;
		case ASCII_l: return 7;
		case ASCII_L: return 7;
		case ASCII_v: return 8;
		case ASCII_V: return 8;
		case ASCII_b: return 9;
		case ASCII_B: return 9;
		case ASCII_A: return 10;
		case ASCII_a: return 10;
		case ASCII_COLON: return 11;
		case ASCII_DOT: return 12;
		case ASCII_CR: return 13;
		case ASCII_LF: return 14;
		case ASCII_SP: return 15;
		case ASCII_MINUS: return 16;
		case ASCII_T: return 17;
		case ASCII_t: return 17;
		case ASCII_W: return 18;
		case ASCII_w: return 18;
	}
	return 0;
}

new satf_lm_spawn_int[MAX_SPAWNS*2];
new Float:satf_lm_spawn_float[MAX_SPAWNS*2][4];
new satf_lm_spawn_index;

new satf_lm_node_int[MAX_CAPPS][3];
new Float:satf_lm_node_float[MAX_CAPPS][4];
new satf_lm_node_index;

new satf_lm_link[MAX_CAPPS*MAX_CAPPS-MAX_CAPPS][2];
new satf_lm_link_index;

new satf_lm_vehicle_int[MAX_VEHICLES][4];
new Float:satf_lm_vehicle_float[MAX_VEHICLES][4];
new satf_lm_vehicle_index;

new Float:satf_lm_wb[4];

new Float:satf_lm_airborne[3];

new satf_lm_time;

new satf_lm_weather;

new xbuffer[16],ybuffer[16],zbuffer[16],abuffer[16],teambuffer[2],modelbuffer[4],color1buffer[4],color2buffer[4],hpbuffer[4],maxhpbuffer[4],link1buffer[4],link2buffer[4],respawnbuffer[4];
new xbuffer_index,ybuffer_index,zbuffer_index,abuffer_index,modelbuffer_index,color1buffer_index,color2buffer_index,hpbuffer_index,maxhpbuffer_index,link1buffer_index,link2buffer_index,respawnbuffer_index;

loadmap(const mapname[]) {
	satf_lm_spawn_index = 0;
	satf_lm_node_index = 0;
	satf_lm_link_index = 0;
	satf_lm_vehicle_index = 0;
	satf_lm_wb[0] = 0.0;
	satf_lm_wb[1] = 0.0;
	satf_lm_wb[2] = 0.0;
	satf_lm_wb[3] = 0.0;
	satf_lm_airborne[0] = 0.0;
	satf_lm_airborne[1] = 0.0;
	satf_lm_airborne[2] = 0.0;
	satf_lm_time = 12;
	satf_lm_weather = 0;
	
	
	parser_state = 1;
	new filename[256];
	strcat(filename, mapname, sizeof(filename));
	strcat(filename, MAP_FEXT, sizeof(filename));
	if(fexist(filename)) {
		new currentChar,old_state;
		new File:mapfile = fopen(filename, io_read);
		new size = flength(mapfile);
		for(new i = 0; i < size; i++) {
			fseek(mapfile,i);
			currentChar = fgetchar(mapfile, false);
			old_state = parser_state;
			parser_state = parser_transition_table[parser_state][translateChar(currentChar)];
			//printf("char %d/%d index %d, old %d new %d", currentChar, translateChar(currentChar), i, old_state, parser_state);
			if(parser_state != 0) {
				processChar(old_state, parser_state, currentChar);
			} else {
				fclose(mapfile);
				printf("error: old state %d, char index %d, char %c/%d", old_state, i, currentChar, currentChar);
				return 0;
			}
		}
		processChar(parser_state, parser_transition_table[parser_state][translateChar(ASCII_LF)], ASCII_LF);
		new accepted;
		for(new i = 0; i < sizeof(parser_accepted_states); i++) {
			if(parser_state == parser_accepted_states[i]) {
				accepted = true;
				break;
			}
		}
		fclose(mapfile);
		return accepted;
	}
	printf("error: file %s does not exist", filename);
	return -1;
}

processChar(old_state, new_state, chara) {
	if(chara == ASCII_SP) return 0;
	//spawns
	if(new_state == STATE_SPAWNS_TEAM) {
		teambuffer[0] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS_X && (old_state == STATE_SPAWNS_X || old_state == STATE_SPAWNS_X_N)) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS_X_D) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS_Y && (old_state == STATE_SPAWNS_Y || old_state == STATE_SPAWNS_Y_N)) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS_Y_D) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS_Z && (old_state == STATE_SPAWNS_Z || old_state == STATE_SPAWNS_Z_N)) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS_Z_D) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS_A && old_state == STATE_SPAWNS_A) {
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS_A_D) {
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_SPAWNS && old_state == STATE_SPAWNS_A_D) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index] = 0;
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index] = 0;
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index] = 0;
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index] = 0;
		if(satf_lm_spawn_index < sizeof(satf_lm_spawn_int)) {
			satf_lm_spawn_int[satf_lm_spawn_index] = strval(teambuffer);
			satf_lm_spawn_float[satf_lm_spawn_index][0] = floatstr(xbuffer);
			satf_lm_spawn_float[satf_lm_spawn_index][1] = floatstr(ybuffer);
			satf_lm_spawn_float[satf_lm_spawn_index][2] = floatstr(zbuffer);
			satf_lm_spawn_float[satf_lm_spawn_index][3] = floatstr(abuffer);
			satf_lm_spawn_index++;
		}
		xbuffer_index = 0;
		ybuffer_index = 0;
		zbuffer_index = 0;
		abuffer_index = 0;
		return 1;
	}
	
	//nodes
	if(new_state == STATE_NODES_TEAM) {
		teambuffer[0] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_HP && (old_state == STATE_NODES_HP || old_state == STATE_NODES_HP_N)) {
		if(hpbuffer_index < sizeof(hpbuffer))
			hpbuffer[hpbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_MAXHP && old_state == STATE_NODES_MAXHP) {
		if(maxhpbuffer_index < sizeof(maxhpbuffer))
			maxhpbuffer[maxhpbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_X && (old_state == STATE_NODES_X || old_state == STATE_NODES_X_N)) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_X_D) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_Y && (old_state == STATE_NODES_Y || old_state == STATE_NODES_Y_N)) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_Y_D) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_Z && (old_state == STATE_NODES_Z || old_state == STATE_NODES_Z_N)) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_Z_D) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_R && old_state == STATE_NODES_R) {
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES_R_D) {
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_NODES && old_state == STATE_NODES_R_D) {
		if(hpbuffer_index < sizeof(hpbuffer))
			hpbuffer[hpbuffer_index] = 0;
		if(maxhpbuffer_index < sizeof(maxhpbuffer))
			maxhpbuffer[maxhpbuffer_index] = 0;
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index] = 0;
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index] = 0;
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index] = 0;
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index] = 0;
		if(satf_lm_node_index < sizeof(satf_lm_node_int)) {
			satf_lm_node_int[satf_lm_node_index][0] = strval(teambuffer);
			satf_lm_node_int[satf_lm_node_index][1] = strval(hpbuffer);
			satf_lm_node_int[satf_lm_node_index][2] = strval(maxhpbuffer);
			satf_lm_node_float[satf_lm_node_index][0] = floatstr(xbuffer);
			satf_lm_node_float[satf_lm_node_index][1] = floatstr(ybuffer);
			satf_lm_node_float[satf_lm_node_index][2] = floatstr(zbuffer);
			satf_lm_node_float[satf_lm_node_index][3] = floatstr(abuffer);
			satf_lm_node_index++;
		}
		hpbuffer_index = 0;
		maxhpbuffer_index = 0;
		xbuffer_index = 0;
		ybuffer_index = 0;
		zbuffer_index = 0;
		abuffer_index = 0;
		return 1;
	}
	if(new_state == STATE_LINKS_LINK1) {
		if(link1buffer_index < sizeof(link1buffer))
			link1buffer[link1buffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_LINKS_LINK2 && old_state == STATE_LINKS_LINK2) {
		if(link2buffer_index < sizeof(link2buffer))
			link2buffer[link2buffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_LINKS && old_state == STATE_LINKS_LINK2) {
		if(link1buffer_index < sizeof(link1buffer))
			link1buffer[link1buffer_index] = 0;
		if(link2buffer_index < sizeof(link2buffer))
			link2buffer[link2buffer_index] = 0;
		if(satf_lm_link_index < sizeof(satf_lm_link)) {
			satf_lm_link[satf_lm_link_index][0] = strval(link1buffer);
			satf_lm_link[satf_lm_link_index][1] = strval(link2buffer);
			satf_lm_link_index++;
		}
		link1buffer_index = 0;
		link2buffer_index = 0;
		return 1;
	}
	if(new_state == STATE_VEHICLES_MODEL) {
		if(modelbuffer_index < sizeof(modelbuffer))
			modelbuffer[modelbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES_COLOR1 && old_state == STATE_VEHICLES_COLOR1) {
		if(color1buffer_index < sizeof(color1buffer))
			color1buffer[color1buffer_index++] = chara;
	}
	if(new_state == STATE_VEHICLES_COLOR2 && old_state == STATE_VEHICLES_COLOR2) {
		if(color2buffer_index < sizeof(color2buffer))
			color2buffer[color2buffer_index++] = chara;
	}
	if(new_state == STATE_VEHICLES_RESPAWNTIME && old_state == STATE_VEHICLES_RESPAWNTIME) {
		if(respawnbuffer_index < sizeof(respawnbuffer))
			respawnbuffer[respawnbuffer_index++] = chara;
	}
	if(new_state == STATE_VEHICLES_X && (old_state == STATE_VEHICLES_X || old_state == STATE_VEHICLES_X_N)) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES_X_D) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES_Y && (old_state == STATE_VEHICLES_Y || old_state == STATE_VEHICLES_Y_N)) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES_Y_D) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES_Z && (old_state == STATE_VEHICLES_Z || old_state == STATE_VEHICLES_Z_N)) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES_Z_D) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES_A && old_state == STATE_VEHICLES_A) {
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES_A_D) {
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_VEHICLES && old_state == STATE_VEHICLES_A_D) {
		if(modelbuffer_index < sizeof(modelbuffer))
			modelbuffer[modelbuffer_index] = 0;
		if(color1buffer_index < sizeof(color1buffer))
			color1buffer[color1buffer_index] = 0;
		if(color2buffer_index < sizeof(color2buffer))
			color2buffer[color2buffer_index] = 0;
		if(respawnbuffer_index < sizeof(respawnbuffer))
			respawnbuffer[respawnbuffer_index] = 0;
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index] = 0;
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index] = 0;
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index] = 0;
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index] = 0;
		if(satf_lm_vehicle_index < sizeof(satf_lm_vehicle_int)) {
			satf_lm_vehicle_int[satf_lm_vehicle_index][0] = strval(modelbuffer);
			satf_lm_vehicle_int[satf_lm_vehicle_index][1] = strval(color1buffer);
			satf_lm_vehicle_int[satf_lm_vehicle_index][2] = strval(color2buffer);
			satf_lm_vehicle_int[satf_lm_vehicle_index][3] = strval(respawnbuffer);
			satf_lm_vehicle_float[satf_lm_vehicle_index][0] = floatstr(xbuffer);
			satf_lm_vehicle_float[satf_lm_vehicle_index][1] = floatstr(ybuffer);
			satf_lm_vehicle_float[satf_lm_vehicle_index][2] = floatstr(zbuffer);
			satf_lm_vehicle_float[satf_lm_vehicle_index][3] = floatstr(abuffer);
			satf_lm_vehicle_index++;
		}
		modelbuffer_index = 0;
		color1buffer_index = 0;
		color2buffer_index = 0;
		respawnbuffer_index = 0;
		xbuffer_index = 0;
		ybuffer_index = 0;
		zbuffer_index = 0;
		abuffer_index = 0;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES_MINX || new_state == STATE_BOUNDARIES_MINX_N) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES_MINX_D) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES_MAXX && (old_state == STATE_BOUNDARIES_MAXX || old_state == STATE_BOUNDARIES_MAXX_N)) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES_MAXX_D) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES_MINY && (old_state == STATE_BOUNDARIES_MINY || old_state == STATE_BOUNDARIES_MINY_N)) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES_MINY_D) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES_MAXY && (old_state == STATE_BOUNDARIES_MAXY || old_state == STATE_BOUNDARIES_MAXY_N)) {
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES_MAXY_D) {
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_BOUNDARIES && old_state == STATE_BOUNDARIES_MAXY_D) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index] = 0;
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index] = 0;
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index] = 0;
		if(abuffer_index < sizeof(abuffer))
			abuffer[abuffer_index] = 0;
		satf_lm_wb[0] = floatstr(xbuffer);
		satf_lm_wb[1] = floatstr(ybuffer);
		satf_lm_wb[2] = floatstr(zbuffer);
		satf_lm_wb[3] = floatstr(abuffer);
		xbuffer_index = 0;
		ybuffer_index = 0;
		zbuffer_index = 0;
		abuffer_index = 0;
		return 1;
	}
	if(new_state == STATE_AIRBORNE_X || new_state == STATE_AIRBORNE_X_N) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_AIRBORNE_X_D) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_AIRBORNE_Y && (old_state == STATE_AIRBORNE_Y || old_state == STATE_AIRBORNE_Y_N)) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_AIRBORNE_Y_D) {
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_AIRBORNE_Z && (old_state == STATE_AIRBORNE_Z || old_state == STATE_AIRBORNE_Z_N)) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_AIRBORNE_Z_D) {
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index++] = chara;
		return 1;
	}
	if(new_state == STATE_AIRBORNE && old_state == STATE_AIRBORNE_Z_D) {
		if(xbuffer_index < sizeof(xbuffer))
			xbuffer[xbuffer_index] = 0;
		if(ybuffer_index < sizeof(ybuffer))
			ybuffer[ybuffer_index] = 0;
		if(zbuffer_index < sizeof(zbuffer))
			zbuffer[zbuffer_index] = 0;
		satf_lm_airborne[0] = floatstr(xbuffer);
		satf_lm_airborne[1] = floatstr(ybuffer);
		satf_lm_airborne[2] = floatstr(zbuffer);
		xbuffer_index = 0;
		ybuffer_index = 0;
		zbuffer_index = 0;
		return 1;
	}
	if(new_state == STATE_TIME_NUMBER) {
		if(modelbuffer_index < sizeof(modelbuffer))
			modelbuffer[modelbuffer_index++] = chara;
	}
	if(new_state == STATE_TIME && old_state == STATE_TIME_NUMBER) {
		if(modelbuffer_index < sizeof(modelbuffer))
			modelbuffer[modelbuffer_index] = 0;
		satf_lm_time = strval(modelbuffer);
		modelbuffer_index = 0;
	}
	if(new_state == STATE_WEATHER_NUMBER) {
		if(modelbuffer_index < sizeof(modelbuffer))
			modelbuffer[modelbuffer_index++] = chara;
	}
	if(new_state == STATE_WEATHER && old_state == STATE_WEATHER_NUMBER) {
		if(modelbuffer_index < sizeof(modelbuffer))
			modelbuffer[modelbuffer_index] = 0;
		satf_lm_weather = strval(modelbuffer);
		modelbuffer_index = 0;
	}
	return 0;
}

createMap() {
	for(new i = 0; i < satf_lm_spawn_index; i++) {
		createSpawn(satf_lm_spawn_int[i], satf_lm_spawn_float[i][0], satf_lm_spawn_float[i][1], satf_lm_spawn_float[i][2], satf_lm_spawn_float[i][3]);
	}
	for(new i = 0; i < satf_lm_node_index; i++) {
		createCapturePoint(satf_lm_node_int[i][0], satf_lm_node_int[i][1], satf_lm_node_int[i][2], satf_lm_node_float[i][0], satf_lm_node_float[i][1], satf_lm_node_float[i][2], satf_lm_node_float[i][3]);
	}
	for(new i = 0; i < satf_lm_link_index; i++) {
		createLink(satf_lm_link[i][0], satf_lm_link[i][1]);
	}
	for(new i = 0; i < satf_lm_vehicle_index; i++) {
		createVehicle(satf_lm_vehicle_int[i][0], satf_lm_vehicle_int[i][1], satf_lm_vehicle_int[i][2], satf_lm_vehicle_int[i][3], satf_lm_vehicle_float[i][0], satf_lm_vehicle_float[i][1], satf_lm_vehicle_float[i][2], satf_lm_vehicle_float[i][3]);
	}
	createWorldBoundaries(satf_lm_wb[0], satf_lm_wb[1], satf_lm_wb[2], satf_lm_wb[3]);
	
	createAirborneSpawn(satf_lm_airborne[0], satf_lm_airborne[1], satf_lm_airborne[2]);
	
	SetWorldTime(satf_lm_time);
	SetWeather(satf_lm_weather);
}
