/*  Team Fortress San Andreas Player Management
 *
 *  (c) Copyright 2007, teh 1337 h4xx0r kru
 *
 */

#if defined _satf_players_included
	#endinput
#endif
#define _satf_players_included

#include <a_samp>
#include <satf_classes>
#include <satf_misc>
#include <satf_maps>
#include <satf_text>

#define NUM_PLAYER_PROPERTIES 5
#define NUM_PPLAYER_PROPERTIES 2
#define PLAYER_TEAM 0
#define PLAYER_CLASS 1
#define PLAYER_XP 2
#define PLAYER_RANK 3
#define PLAYER_CAR 4

new satf_players[MAX_PLAYERS][NUM_PLAYER_PROPERTIES];
new satf_potential_players[MAX_PLAYERS][NUM_PPLAYER_PROPERTIES];
new satf_player_names[MAX_PLAYERS][MAX_PLAYER_NAME];

#define MAX_SEATS 4
new satf_vehicles_players[MAX_VEHICLES][MAX_SEATS];

#define POS_X 0
#define POS_Y 1
#define POS_Z 2

new Float:satf_players_position[MAX_PLAYERS][3];

#define MAX_VEHICLE_HEALTH 1000.0
#define MIN_VEHICLE_HEALTH 250.0
#define KEY_SPECIAL1 8192
#define KEY_SPECIAL2 16384
new maxPlayers;

new even_tick;

#define MAX_WEAPONS 43
new weapon_slots[MAX_WEAPONS];
new spyundercover[MAX_PLAYERS];
new spawned_vehicles[MAX_VEHICLES][2];
new engineervehicle[MAX_PLAYERS];
new Float:respawnhost_float[MAX_PLAYERS][MAX_SPAWN_PROPS];
new respawnhost_int[MAX_PLAYERS][2];

#define NUM_SPECIALS 2
#define SPECIAL1 0
#define SPECIAL2 1
new player_cooldown[MAX_PLAYERS][NUM_SPECIALS];
//new keypressed[MAX_PLAYERS];

new vehicleSpawned[MAX_VEHICLES];

new playerAlive[MAX_PLAYERS];
new playerJustSpawned[MAX_PLAYERS];

new team_stats[2];
new class_stats[2][NUM_CLASSES];
/******* General Player Management ********/

initPlayers() {
	maxPlayers = GetMaxPlayers();
	for(new i = 0; i < MAX_PLAYERS; i++) {
		satf_players[i][PLAYER_CLASS] = CLASS_NOT_CONNECTED;
	}
	for(new i = 0; i < MAX_VEHICLES; i++) {
		for(new j = 0; j < MAX_SEATS; j++) {
			satf_vehicles_players[i][j] = INVALID_PLAYER_ID;
		}
	}
	weapon_slots[0] = 0;
	weapon_slots[24] = 2;
	weapon_slots[22] = 2;
	weapon_slots[28] = 4;
	weapon_slots[29] = 4;
	weapon_slots[31] = 5;
	weapon_slots[25] = 3;
	weapon_slots[27] = 3;
	weapon_slots[37] = 7;
	weapon_slots[35] = 7;
	weapon_slots[18] = 8;
	weapon_slots[17] = 8;
	weapon_slots[16] = 8;
	weapon_slots[33] = 6;
	weapon_slots[23] = 2;
	weapon_slots[34] = 6;
	weapon_slots[4] = 1;
	weapon_slots[6] = 1;
	weapon_slots[15] = 1;
	weapon_slots[42] = 9;
	
	for(new i = 0; i < MAX_PLAYERS; i++) {
		engineervehicle[i] = INVALID_VEHICLE_ID;
	}
}

cleanupPlayers() {
	for(new i = 0; i < maxPlayers; i++) {
		if(respawnhost_int[i][0] > 0) {
			DestroyObject(respawnhost_int[i][1]);
			respawnhost_int[i][0] = 0;
		}
		if(engineervehicle[i] != INVALID_VEHICLE_ID) {
			spawned_vehicles[engineervehicle[i]][0] = false;
			spawned_vehicles[engineervehicle[i]][1] = INVALID_PLAYER_ID;
			DestroyVehicle(engineervehicle[i]);
			engineervehicle[i] = INVALID_VEHICLE_ID;
		}
		player_cooldown[i][SPECIAL1] = 0;
		player_cooldown[i][SPECIAL2] = 0;
		if(satf_players[i][PLAYER_CLASS] == CLASS_SPY && spyundercover[i]) {
			spyuncoverkill(i);
		} else if(satf_players[i][PLAYER_CLASS] == CLASS_SNIPER && spyundercover[i]) {
			spyundercover[i] = false;
		}
		if(satf_players[i][PLAYER_CLASS] == CLASS_SNIPER && spyundercover[i]) {
			DisablePlayerCheckpoint(i);
			SetPlayerInterior(i, 0);
			spyundercover[i] = false;
		}
	}
}

createPlayer(playerid, playerteam, playerclass) { //temporarily save the players selection at OnPlayerRequestClass
	satf_potential_players[playerid][PLAYER_TEAM] = playerteam;
	satf_potential_players[playerid][PLAYER_CLASS] = playerclass;
}

updatePlayer(playerid) { //put the player in to playerlist at spawn or update his information
	if(satf_players[playerid][PLAYER_CLASS] != satf_potential_players[playerid][PLAYER_CLASS] || satf_players[playerid][PLAYER_TEAM] != satf_potential_players[playerid][PLAYER_TEAM]) {//player has changed his class or has just joined the server
		if(satf_players[playerid][PLAYER_CLASS] == CLASS_NOT_CONNECTED) {
			gainRank(playerid, RANK_PRIVATE);
			satf_players[playerid][PLAYER_XP] = 0;
		}
		satf_players[playerid][PLAYER_TEAM] = satf_potential_players[playerid][PLAYER_TEAM];
		satf_players[playerid][PLAYER_CLASS] = satf_potential_players[playerid][PLAYER_CLASS];
		satf_players[playerid][PLAYER_CAR] = INVALID_VEHICLE_ID;
	}
	SetPlayerHealth(playerid, satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][HEALTH]);
	SetPlayerArmour(playerid, satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][ARMOUR]);
	playerAlive[playerid] = true;
	SetPlayerColor(playerid, satf_team_colors[satf_players[playerid][PLAYER_TEAM]]);
	playerJustSpawned[playerid] = true;
}

deletePlayer(playerid) {
	satf_players[playerid][PLAYER_CLASS] = CLASS_NOT_CONNECTED;
	removeFromVehicle(playerid, satf_players[playerid][PLAYER_CAR]);
	player_cooldown[playerid][SPECIAL1] = 0;
	player_cooldown[playerid][SPECIAL2] = 0;
}

resetPlayers() {
	balanceTeams();
	for(new i = 0; i < maxPlayers; i++) {
		if(IsPlayerConnected(i)) {
			if(satf_players[i][PLAYER_CLASS] != CLASS_NOT_CONNECTED) {
				setPlayerNextSpawn(i, satf_players[i][PLAYER_CLASS], satf_players[i][PLAYER_TEAM]);
				SpawnPlayer(i);
			}
			TogglePlayerControllable(i, true);
		}
	}
}

balanceTeams() {
	if(abs(team_stats[TEAM_ALPHA]-team_stats[TEAM_BETA]) > 1) {
		changeTeam(team_stats[TEAM_ALPHA]>team_stats[TEAM_BETA]?TEAM_ALPHA:TEAM_BETA, abs(team_stats[TEAM_ALPHA]-team_stats[TEAM_BETA])/2);
	}
}

changeTeam(teamid, num_players) {
	new playerid;
	for(new i = 0; i < num_players; i++) {
		while(1) {
			playerid = random(maxPlayers);
			if(satf_players[playerid][PLAYER_CLASS] != CLASS_NOT_CONNECTED && satf_players[playerid][PLAYER_TEAM] == teamid) {
				satf_players[playerid][PLAYER_TEAM] = !teamid;
				satf_potential_players[playerid][PLAYER_TEAM] = !teamid;
				break;
			}
		}
	}
	GameTextForAll("Balancing teams", 2000, 4);
}

givePlayerXP(playerid, xp) {
	satf_players[playerid][PLAYER_XP] += xp;
}

isPlayerActive(playerid) {
	return (satf_players[playerid][PLAYER_CLASS] != CLASS_NOT_CONNECTED);
}

updatePlayerPositions() {
	new Float:x,Float:y,Float:z;
	for(new i = 0; i < maxPlayers; i++) {
		if(isPlayerActive(i)) {
			GetPlayerPos(i, x, y, z);
			satf_players_position[i][POS_X] = x;
			satf_players_position[i][POS_Y] = y;
			satf_players_position[i][POS_Z] = z;
		}
	}
}

/*updatePlayerPosition(playerid) {
	new Float:x,Float:y,Float:z;
	GetPlayerPos(playerid, x, y, z);
	satf_players_position[playerid][POS_X] = x;
	satf_players_position[playerid][POS_Y] = y;
	satf_players_position[playerid][POS_Z] = z;
}*/

updatePlayerScores() {
	for(new i = 0; i < maxPlayers; i++) {
		if(isPlayerActive(i)) {
			SetPlayerScore(i, satf_players[i][PLAYER_XP]);
			ResetPlayerMoney(i);
			GivePlayerMoney(i, satf_players[i][PLAYER_XP]);
			if(satf_players[i][PLAYER_XP] < satf_rank_steps[RANK_SERGEANT]) {
				SetPlayerWantedLevel(i, 1);
			} else if(satf_players[i][PLAYER_XP] < satf_rank_steps[RANK_LIEUTENANT]) {
				SetPlayerWantedLevel(i, 2);
				if(satf_players[i][PLAYER_RANK] < RANK_SERGEANT) {
					gainRank(i, RANK_SERGEANT);
				}
			} else if(satf_players[i][PLAYER_XP] < satf_rank_steps[RANK_MAJOR]) {
				SetPlayerWantedLevel(i, 3);
				if(satf_players[i][PLAYER_RANK] < RANK_LIEUTENANT) {
					gainRank(i, RANK_LIEUTENANT);
				}
			} else if(satf_players[i][PLAYER_XP] < satf_rank_steps[RANK_COLONEL]) {
				SetPlayerWantedLevel(i, 4);
				if(satf_players[i][PLAYER_RANK] < RANK_MAJOR) {
					gainRank(i, RANK_MAJOR);
				}
			} else if(satf_players[i][PLAYER_XP] < satf_rank_steps[RANK_GENERAL]) {
				SetPlayerWantedLevel(i, 5);
				if(satf_players[i][PLAYER_RANK] < RANK_COLONEL) {
					gainRank(i, RANK_COLONEL);
				}
			} else {
				SetPlayerWantedLevel(i, 6);
				if(satf_players[i][PLAYER_RANK] < RANK_GENERAL) {
					gainRank(i, RANK_GENERAL);
				}
			}
		}
	}
}

gainRank(playerid, rank) {
	new string[128];
	new name[MAX_PLAYER_NAME];
	format(name, MAX_PLAYER_NAME, "%s_%s", satf_rank_short_names[rank], satf_player_names[playerid]);
	SetPlayerName(playerid, name);
	if(rank < RANK_GENERAL) {
		format(string, sizeof(string), "You have reached the rank of a %s. Next rank with %d XP.", satf_rank_names[rank], satf_rank_steps[rank+1]);
	} else {
		format(string, sizeof(string), "You have reached the rank of a %s. CONGRATULATIONS!", satf_rank_names[rank]);
	}
	SendClientMessage(playerid, COLOR_YELLOW, string);
	satf_players[playerid][PLAYER_RANK] = rank;
	if(satf_players[playerid][PLAYER_CLASS] != CLASS_NOT_CONNECTED) {
		SetPlayerHealth(playerid, satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][HEALTH]);
		SetPlayerArmour(playerid, satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][ARMOUR]);
		refreshPlayerAmmo(playerid);
	}
}

handlePlayerDeath(playerid, killerid) {
	playerAlive[playerid] = false;
	if(killerid != INVALID_PLAYER_ID && killerid != playerid && satf_players[killerid][PLAYER_TEAM] != satf_players[playerid][PLAYER_TEAM]) {
		givePlayerXP(killerid, 25);
	}
	if(killerid != INVALID_PLAYER_ID && satf_players[killerid][PLAYER_TEAM] == satf_players[playerid][PLAYER_TEAM]) {
		//givePlayerXP(killerid, -25);
		GameTextForPlayer(killerid, "~r~Don't kill your teammates!", 3000, 4);
	}
	removeFromVehicle(playerid, satf_players[playerid][PLAYER_CAR]);
	if(satf_players[playerid][PLAYER_CLASS] == CLASS_SPY && spyundercover[playerid]) {
		spyuncoverdeath(playerid);
	}
	if(killerid != INVALID_PLAYER_ID && satf_players[killerid][PLAYER_CLASS] == CLASS_SPY && spyundercover[killerid]) {
		spyuncoverkill(killerid);
	}
	setPlayerNextSpawn(playerid, satf_players[playerid][PLAYER_CLASS], satf_players[playerid][PLAYER_TEAM]);
	if(satf_players[playerid][PLAYER_CLASS] == CLASS_SNIPER && spyundercover[playerid]) {
		SetPlayerInterior(playerid, 0);
		spyundercover[playerid] = false;
		DisablePlayerCheckpoint(playerid);
	}
}

handlePlayerSpawn(playerid) {
	updatePlayer(playerid);
	for(new i = 0; i < maxPlayers; i++) {
		if(satf_players[playerid][PLAYER_TEAM] == satf_players[i][PLAYER_TEAM] && respawnhost_int[i][0] > 0) {
			SetPlayerPos(playerid, respawnhost_float[i][SPAWN_X], respawnhost_float[i][SPAWN_Y], respawnhost_float[i][SPAWN_Z]);
			SetPlayerFacingAngle(playerid, respawnhost_float[i][SPAWN_A]);
			respawnhost_int[i][0]--;
			if(respawnhost_int[i][0] == 0) {
				DestroyObject(respawnhost_int[i][1]);
				if(satf_players[i][PLAYER_CLASS] == CLASS_MEDIC)
					player_cooldown[i][SPECIAL2] = satf_rank_properties[CLASS_MEDIC][satf_players[i][PLAYER_RANK]][COOLDOWN2];
			}
			break;
		}
	}
}

handleVehicleDeath(vehicleid) {
	if(vehicleid == INVALID_VEHICLE_ID) return 0;
	for(new i = 0; i < MAX_SEATS; i++) {
		satf_vehicles_players[vehicleid][i] = INVALID_PLAYER_ID;
	}
	if(spawned_vehicles[vehicleid][0]) {
		DestroyVehicle(vehicleid);
		spawned_vehicles[vehicleid][0] = false;
		engineervehicle[spawned_vehicles[vehicleid][1]] = INVALID_VEHICLE_ID;
		player_cooldown[spawned_vehicles[vehicleid][1]][SPECIAL2] = satf_rank_properties[CLASS_ENGINEER][satf_players[spawned_vehicles[vehicleid][1]][PLAYER_RANK]][COOLDOWN2];
	}
	return 1;
}

handlePlayerEnterVehicle(playerid, vehicleid) {
	if(vehicleid == INVALID_VEHICLE_ID || playerid == INVALID_PLAYER_ID) return 0;
	satf_players[playerid][PLAYER_CAR] = vehicleid;
	for(new i = 0; i < MAX_SEATS; i++) {
		if(satf_vehicles_players[vehicleid][i] != INVALID_PLAYER_ID) {
			if(GetPlayerVehicleID(satf_vehicles_players[vehicleid][i]) != vehicleid) {
				satf_players[satf_vehicles_players[vehicleid][i]][PLAYER_CAR] = INVALID_VEHICLE_ID;
				satf_vehicles_players[vehicleid][i] = INVALID_PLAYER_ID;
			}
		}
	}
	for(new i = 0; i < MAX_SEATS; i++) {
		if(satf_vehicles_players[vehicleid][i] == INVALID_PLAYER_ID) {
			satf_vehicles_players[vehicleid][i] = playerid;
			return 1;
		}
	}
	return 0;
}

handlePlayerExitVehicle(playerid, vehicleid) {
	return removeFromVehicle(playerid, vehicleid);
}

removeFromVehicle(playerid, vehicleid) {
	if(vehicleid == INVALID_VEHICLE_ID || playerid == INVALID_PLAYER_ID) return 0;
	satf_players[playerid][PLAYER_CAR] = INVALID_VEHICLE_ID;
	for(new i = 0; i < MAX_SEATS; i++) {
		if(satf_vehicles_players[vehicleid][i] == playerid) {
			satf_vehicles_players[vehicleid][i] = INVALID_PLAYER_ID;
			return 1;
		}
	}
	return 0;
}

setPlayerSpawn(playerid, classid, Float:x, Float:y, Float:z, Float:a) {
	new rank;
	if(satf_players[playerid][PLAYER_CLASS] == CLASS_NOT_CONNECTED) {
		rank = RANK_PRIVATE;
	} else {
		rank = satf_players[playerid][PLAYER_RANK];
	}
	SetSpawnInfo(playerid,0,satf_classes[classid][SKIN],x,y,z,a,satf_classes[classid][WEAPON0],satf_rank_properties[classid][rank][AMMO0],satf_classes[classid][WEAPON1],satf_rank_properties[classid][rank][AMMO1],satf_classes[classid][WEAPON2],satf_rank_properties[classid][rank][AMMO2]);
}

setPlayerNextSpawn(playerid, classid, teamid) {
	new Float:x,Float:y,Float:z,Float:a;
	getNextSpawn(teamid, x, y, z, a);
	setPlayerSpawn(playerid, classid, x, y, z, a);
}

/********* Support Funktions ***************/
/*isPlayerInRangeOfPlayer(player1, player2, Float:range) {
	return (distanceBetweenPoints3d(satf_players_position[player1][POS_X], satf_players_position[player1][POS_Y], satf_players_position[player1][POS_Z], satf_players_position[player2][POS_X], satf_players_position[player2][POS_Y], satf_players_position[player2][POS_Z]) <= range);
}*/

isPlayerInsideArea(playerid, Float:minx, Float:maxx, Float:miny, Float:maxy) {
	return (satf_players_position[playerid][POS_X] > minx && satf_players_position[playerid][POS_X] < maxx && satf_players_position[playerid][POS_Y] > miny && satf_players_position[playerid][POS_Y] < maxy);
}

/*isPlayerAlive(playerid) {
	return playerAlive[playerid];
}*/

/********* Special Abilities ***************/
isPointInActionRange(player1, Float:x2, Float:y2, Float:z2, Float:distance, Float:sightangle) {
	new Float:x1,Float:y1,Float:z1,Float:a1,Float:a2,Float:d;
	GetPlayerPos(player1, x1, y1, z1);
	GetPlayerFacingAngle(player1, a1);
	d = distanceBetweenPoints2d(x1, y1, x2, y2);
	a2 = asin((x2-x1)/d)<=0.0?acos((y2-y1)/d):360.0-acos((y2-y1)/d);
	return floatabs(a1-a2) <= sightangle/2.0 && distanceBetweenPoints3d(x1,y1,z1,x2,y2,z2) <= distance;
}

isPlayerInActionRange(player1, player2, Float:distance, Float:sightangle) {
	new Float:x, Float:y, Float:z;
	GetPlayerPos(player2, x, y, z);
	return isPointInActionRange(player1, x, y, z, distance, sightangle);
}

getPlayerKey(playerid) {
	new keys,updown,leftright;
	GetPlayerKeys(playerid, keys, updown, leftright);
	return keys;
}

player_timer() {
	for(new i = 0; i < 2; i++) {
		team_stats[i] = 0;
		for(new j = 0; j < NUM_CLASSES; j++) {
			class_stats[i][j] = 0;
		}
	}
	for(new i = 0; i < maxPlayers; i++) {
		if(IsPlayerConnected(i)) {
			if(satf_players[i][PLAYER_CLASS] != CLASS_NOT_CONNECTED) {
				team_stats[satf_players[i][PLAYER_TEAM]]++;
				class_stats[satf_players[i][PLAYER_TEAM]][satf_players[i][PLAYER_CLASS]]++;
			}
		if(playerJustSpawned[i]) {
			playerJustSpawned[i] = false;
			for(new j = 0; j < maxPlayers; j++) {
				if(satf_players[i][PLAYER_TEAM] == satf_players[j][PLAYER_TEAM]) {
					ShowPlayerNameTagForPlayer(j, i, true);
					SetPlayerMarkerForPlayer(j, i, satf_team_colors[satf_players[i][PLAYER_TEAM]]);
					ShowPlayerNameTagForPlayer(i, j, true);
					SetPlayerMarkerForPlayer(i, j, satf_team_colors[satf_players[i][PLAYER_TEAM]]);
				} else {
					ShowPlayerNameTagForPlayer(j, i, false);
					SetPlayerMarkerForPlayer(j, i, satf_team_colors_a[satf_players[i][PLAYER_TEAM]]);
					ShowPlayerNameTagForPlayer(i, j, false);
					SetPlayerMarkerForPlayer(i, j, satf_team_colors_a[!satf_players[i][PLAYER_TEAM]]);
				}
			}
		}
		if(!IsPlayerInAnyVehicle(i)) {
			if(satf_players[i][PLAYER_CLASS] == CLASS_MEDIC) {
				if(player_cooldown[i][SPECIAL2] > 0) {
					player_cooldown[i][SPECIAL2]--;
				}
				if(getPlayerKey(i) == KEY_SPECIAL1) {
					for(new j = 0; j < maxPlayers; j++) {
						if(IsPlayerConnected(j) && i != j && satf_players[i][PLAYER_TEAM] == satf_players[j][PLAYER_TEAM]) {
							if(isPlayerInActionRange(i, j, 1.0, 90.0)) {
								if(medicHealPlayer(i, j)) break;
							}
						}
					}
				} else if(getPlayerKey(i) == KEY_SPECIAL2 && player_cooldown[i][SPECIAL2] == 0) {
					if(respawnhost_int[i][0] == 0) medicRespawnHost(i);
				}
			} else if(satf_players[i][PLAYER_CLASS] == CLASS_ENGINEER) {
				if(player_cooldown[i][SPECIAL2] > 0) {
					player_cooldown[i][SPECIAL2]--;
				}
				if(getPlayerKey(i) == KEY_SPECIAL1) {
					for(new j = 0; j < MAX_VEHICLES; j++) {
						if(vehicleSpawned[j]) {
							if(isVehicleInActionRange(i, j, 3.0, 135.0)) {
								if(engineerRepairVehicle(i, j)) break;
							}
						}
					}
				} else if(getPlayerKey(i) == KEY_SPECIAL2 && player_cooldown[i][SPECIAL2] == 0) {
					engineerSpawnVehicle(i);
				}
			} else if(satf_players[i][PLAYER_CLASS] == CLASS_SUPPLY) {
				if(player_cooldown[i][SPECIAL1] > 0) {
					player_cooldown[i][SPECIAL1]--;
				}
				if(player_cooldown[i][SPECIAL2] > 0) {
					player_cooldown[i][SPECIAL2]--;
				}
				if(getPlayerKey(i) == KEY_SPECIAL1 && player_cooldown[i][SPECIAL1] == 0) {
						for(new j = 0; j < maxPlayers; j++) {
							if(IsPlayerConnected(j) && i != j && satf_players[i][PLAYER_TEAM] == satf_players[j][PLAYER_TEAM]) {
								if(isPlayerInActionRange(i, j, 1.0, 90.0)) {
									if(supplyGiveArmour(i, j)) break;
								}
							}
						}
				} else if(getPlayerKey(i) == KEY_SPECIAL2 && player_cooldown[i][SPECIAL2] == 0) {
						for(new j = 0; j < maxPlayers; j++) {
							if(IsPlayerConnected(j) && i != j && satf_players[i][PLAYER_TEAM] == satf_players[j][PLAYER_TEAM]) {
								if(isPlayerInActionRange(i, j, 1.0, 90.0)) {
									if(supplyGiveAmmo(i, j)) break;
								}
							}
						}
					}
			} else if(satf_players[i][PLAYER_CLASS] == CLASS_SPY) {
				if(player_cooldown[i][SPECIAL1] > 0) {
					player_cooldown[i][SPECIAL1]--;
				}
				if(player_cooldown[i][SPECIAL2] > 0) {
					player_cooldown[i][SPECIAL2]--;
				}
				if(getPlayerKey(i) == KEY_SPECIAL1/* && !keypressed[i]*/) {
					//keypressed[i] = true;
					if(player_cooldown[i][SPECIAL1] == 0 && !spyundercover[i]) {
						spycover(i);
					} else if(spyundercover[i]) {
						spyuncoverkill(i);
					}
				} else if(getPlayerKey(i) == KEY_SPECIAL2 && player_cooldown[i][SPECIAL2] == 0) {
						basetelep(i);
				}/* else if(getPlayerKey(i) == 0) {
					keypressed[i] = false;
				}*/
			} else if(satf_players[i][PLAYER_CLASS] == CLASS_SNIPER) {
				if(player_cooldown[i][SPECIAL1] > 0) {
					player_cooldown[i][SPECIAL1]--;
				}
				if(player_cooldown[i][SPECIAL2] > 0) {
					player_cooldown[i][SPECIAL2]--;
				}
				if(getPlayerKey(i) == KEY_SPECIAL1 && player_cooldown[i][SPECIAL1] == 0) {
						sniperairborne(i);
				} else if(getPlayerKey(i) == KEY_SPECIAL2 && player_cooldown[i][SPECIAL2] == 0) {
						basetelep(i);
				}
			}
		}
		}
	}
}

medicHealPlayer(medicid, playerid) {
	new Float:g;
	GetPlayerHealth(playerid, g);
	if(g < satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][HEALTH]) {
		SetPlayerHealth(playerid, g+satf_rank_properties[CLASS_MEDIC][satf_players[medicid][PLAYER_RANK]][CLASS_SPECIAL1]);
		player_cooldown[medicid][SPECIAL1] = satf_rank_properties[CLASS_MEDIC][satf_players[medicid][PLAYER_RANK]][COOLDOWN1];
		givePlayerXP(medicid, 1);
		TextDrawShowForPlayer(playerid, beingHealed);
		TextDrawShowForPlayer(medicid, healing);
		return 1;
	}
	return 0;
}

engineerRepairVehicle(playerid, vehicleid) {
	new Float:g;
	GetVehicleHealth(vehicleid, g);
	if(g < MAX_VEHICLE_HEALTH && g > MIN_VEHICLE_HEALTH) {
		SetVehicleHealth(vehicleid, g+satf_rank_properties[CLASS_ENGINEER][satf_players[playerid][PLAYER_RANK]][CLASS_SPECIAL1]);
		player_cooldown[playerid][SPECIAL1] = satf_rank_properties[CLASS_ENGINEER][satf_players[playerid][PLAYER_RANK]][COOLDOWN1];
		givePlayerXP(playerid, 1);
		TextDrawShowForPlayer(playerid, repairing);
		for(new i = 0; i < MAX_SEATS; i++) {
			if(satf_vehicles_players[vehicleid][i] != INVALID_PLAYER_ID) {
				TextDrawShowForPlayer(satf_vehicles_players[vehicleid][i], beingRepaired);
			}
		}
		return 1;
	}
	return 0;
}

supplyGiveArmour(supplyid, playerid) {
	new Float:a;
	GetPlayerArmour(playerid, a);
	if(a < satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][ARMOUR]) {
		SetPlayerArmour(playerid, satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][ARMOUR]);
		givePlayerXP(supplyid, 10);
		player_cooldown[supplyid][SPECIAL1] = satf_rank_properties[CLASS_SUPPLY][satf_players[supplyid][PLAYER_RANK]][COOLDOWN1];
		TextDrawShowForPlayer(playerid, gotArmour);
		TextDrawShowForPlayer(supplyid, giveArmour);
		return 1;
	}
	return 0;
}

supplyGiveAmmo(supplyid, playerid) {
	if(refreshPlayerAmmo(playerid)) {
		givePlayerXP(supplyid, 10);
		player_cooldown[supplyid][SPECIAL2] = satf_rank_properties[CLASS_SUPPLY][satf_players[supplyid][PLAYER_RANK]][COOLDOWN2];
		TextDrawShowForPlayer(playerid, gotAmmo);
		TextDrawShowForPlayer(supplyid, giveAmmo);
		return 1;
	}
	return 0;
}

refreshPlayerAmmo(playerid) {
	new weap, weap1, weap2, weap3, ammo, ammo1, ammo2, ammo3, slot1, slot2, slot3, gaveAmmo;
	weap1 = satf_classes[satf_players[playerid][PLAYER_CLASS]][WEAPON0];
	slot1 = weapon_slots[weap1];
	ammo1 = satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][AMMO0];
	weap2 = satf_classes[satf_players[playerid][PLAYER_CLASS]][WEAPON1];
	ammo2 = satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][AMMO1];
	slot2 = weapon_slots[weap2];
	weap3 = satf_classes[satf_players[playerid][PLAYER_CLASS]][WEAPON2];
	ammo3 = satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][AMMO2];
	slot3 = weapon_slots[weap3];
	
	if(weap1 != 0) {
		GetPlayerWeaponData(playerid, slot1, weap, ammo);
		if(ammo < ammo1) {
			GivePlayerWeapon(playerid, weap1, ammo1-ammo);
			gaveAmmo = true;
		}
	}
	if(weap2 != 0) {
		GetPlayerWeaponData(playerid, slot2, weap, ammo);
		if(ammo < ammo2) {
			GivePlayerWeapon(playerid, weap2, ammo2-ammo);
			gaveAmmo = true;
		}
	}
	if(weap3 != 0) {
		GetPlayerWeaponData(playerid, slot3, weap, ammo);
		if(ammo < ammo3) {
			GivePlayerWeapon(playerid, weap3, ammo3-ammo);
			gaveAmmo = true;
		}
	}
	return gaveAmmo;
}

isVehicleInActionRange(player, vehicle, Float:distance, Float:radius) {
	new Float:x, Float:y, Float:z;
	GetVehiclePos(vehicle, x, y, z);
	return isPointInActionRange(player, x, y, z, distance, radius);
}

spycover(playerid) {
		spyundercover[playerid] = true;
		new Float:x,Float:y,Float:z;
		GetPlayerPos(playerid, x ,y, z);
		SetPlayerSkin(playerid,getRandomSkin());
		SetPlayerPos(playerid, x, y, z);
		TextDrawShowForPlayer(playerid, cover);
		SetPlayerColor(playerid, satf_team_colors[!satf_players[playerid][PLAYER_TEAM]]);
		for(new i = 0; i < maxPlayers; i++) {
			if(satf_players[playerid][PLAYER_TEAM] != satf_players[i][PLAYER_TEAM] && satf_players[i][PLAYER_CLASS] != CLASS_NOT_CONNECTED) {
				ShowPlayerNameTagForPlayer(i, playerid, true);
				SetPlayerMarkerForPlayer(i, playerid, satf_team_colors[!satf_players[playerid][PLAYER_TEAM]]);
			} else if(satf_players[playerid][PLAYER_TEAM] == satf_players[i][PLAYER_TEAM] && satf_players[i][PLAYER_CLASS] != CLASS_NOT_CONNECTED) {
				SetPlayerMarkerForPlayer(i, playerid, satf_team_colors[satf_players[playerid][PLAYER_TEAM]]);
			}
		}
}

spyuncoverdeath(playerid) {
	setPlayerNextSpawn(playerid, CLASS_SPY, satf_players[playerid][PLAYER_TEAM]);
	spyundercover[playerid] = false;
	TextDrawShowForPlayer(playerid, uncover);
	SetPlayerColor(playerid, satf_team_colors[satf_players[playerid][PLAYER_TEAM]]);
	spyresetteamcolor(playerid);
}

spyuncoverkill(playerid) {
	SetPlayerSkin(playerid,satf_classes[CLASS_SPY][SKIN]);
	ClearAnimations(playerid);
	spyundercover[playerid] = false;
	player_cooldown[playerid][SPECIAL1] = satf_rank_properties[CLASS_SPY][satf_players[playerid][PLAYER_RANK]][COOLDOWN1];
	TextDrawShowForPlayer(playerid, uncover);
	SetPlayerColor(playerid, satf_team_colors[satf_players[playerid][PLAYER_TEAM]]);
	spyresetteamcolor(playerid);
}

spyresetteamcolor(playerid) {
	for(new i = 0; i < maxPlayers; i++) {
		if(satf_players[playerid][PLAYER_TEAM] != satf_players[i][PLAYER_TEAM]) {
			ShowPlayerNameTagForPlayer(i, playerid, false);
			SetPlayerMarkerForPlayer(i, playerid, satf_team_colors_a[satf_players[playerid][PLAYER_TEAM]]);
		}
	}
}

basetelep(playerid) {
	new Float:x,Float:y,Float:z,Float:a;
	getNextSpawn(satf_players[playerid][PLAYER_TEAM], x, y, z, a);
	if(satf_players[playerid][PLAYER_CLASS] == CLASS_SNIPER && spyundercover[playerid]) {
		SetPlayerInterior(playerid, 0);
		spyundercover[playerid] = false;
		DisablePlayerCheckpoint(playerid);
	}
	SetPlayerPos(playerid, x,y,z);
	SetPlayerFacingAngle(playerid, a);
	player_cooldown[playerid][SPECIAL2] = satf_rank_properties[satf_players[playerid][PLAYER_CLASS]][satf_players[playerid][PLAYER_RANK]][COOLDOWN2];
	TextDrawShowForPlayer(playerid, baseteleport);
}

getRandomSkin() {
	return satf_classes[random(NUM_CLASSES)][SKIN];
}

/*sniperairborne(playerid) {
	new weapon,ammo;
	GetPlayerWeaponData(playerid, 9, weapon, ammo);
	if(weapon != 46) {
		new Float:x,Float:y,Float:z;
		GetPlayerPos(playerid, x, y, z);
		GivePlayerWeapon(playerid,46,1);
		SetPlayerPos(playerid, x, y, z+SNIPER_AIRBORE_HEIGHT);
		player_cooldown[playerid][SPECIAL1] = satf_rank_properties[CLASS_SNIPER][satf_players[playerid][PLAYER_RANK]][COOLDOWN1];
		TextDrawShowForPlayer(playerid, airborne);
	}
}*/

sniperairborne(playerid) {
	SetPlayerInterior(playerid, 9);
	SetPlayerPos(playerid, 315.8637,1009.6103,1953.2327);
	SetPlayerFacingAngle(playerid, 359.7681);
	spyundercover[playerid] = true;
	SetPlayerCheckpoint(playerid, 315.8203,1034.1213,1943.5, 5.0);
	new weapon,ammo;
	GetPlayerWeaponData(playerid, 9, weapon, ammo);
	if(weapon != 46) {
		GivePlayerWeapon(playerid,46,1);
	}
	TextDrawShowForPlayer(playerid, airborne);
}

sniperairborne_jump(playerid) {
	DisablePlayerCheckpoint(playerid);
	if(satf_players[playerid][PLAYER_CLASS] == CLASS_SNIPER && spyundercover[playerid]) {
		SetPlayerInterior(playerid, 0);
		SetPlayerPos(playerid, airborne_pos[SPAWN_X], airborne_pos[SPAWN_Y], airborne_pos[SPAWN_Z]+satf_rank_properties[CLASS_SNIPER][satf_players[playerid][PLAYER_RANK]][CLASS_SPECIAL1]);
		spyundercover[playerid] = false;
	}
}

engineerSpawnVehicle(playerid) {
	if(engineervehicle[playerid] == INVALID_VEHICLE_ID) {
		new Float:x,Float:y,Float:z,Float:a,Float:newx,Float:newy;
		GetPlayerPos(playerid, x, y, z);
		GetPlayerFacingAngle(playerid, a);
		getPointInDistanceOfPoint2d(x, y, a, 3.0, newx, newy);
		engineervehicle[playerid] = CreateVehicle(470,newx,newy,z,a-90.0,satf_team_colors_car[satf_players[playerid][PLAYER_TEAM]],1,60);
		spawned_vehicles[engineervehicle[playerid]][0] = true;
		spawned_vehicles[engineervehicle[playerid]][1] = playerid;
		vehicleSpawned[engineervehicle[playerid]] = true;
		TextDrawShowForPlayer(playerid, spawnedVehicle);
		givePlayerXP(playerid, 10);
	}
}

medicRespawnHost(playerid) {
	if(GetPlayerInterior(playerid) == 0) {
		new Float:x,Float:y,Float:z,Float:a,Float:newx,Float:newy;
		GetPlayerPos(playerid, x, y, z);
		GetPlayerFacingAngle(playerid, a);
		getPointInDistanceOfPoint2d(x, y, a, 2.0, newx, newy);
		respawnhost_float[playerid][SPAWN_X] = newx;
		respawnhost_float[playerid][SPAWN_Y] = newy;
		respawnhost_float[playerid][SPAWN_Z] = z;
		respawnhost_float[playerid][SPAWN_A] = a;
		respawnhost_int[playerid][0] = satf_rank_properties[CLASS_MEDIC][satf_players[playerid][PLAYER_RANK]][CLASS_SPECIAL2];
		respawnhost_int[playerid][1] = CreateObject(1318,newx,newy,z,0,0,0);
		TextDrawShowForPlayer(playerid, spawnedHost);
		givePlayerXP(playerid, 10);
	}
}
