/*  Team Fortress San Andreas Map Funktions
 *
 *  (c) Copyright 2007, teh 1337 h4xx0r crew
 *
 */

#if defined _satf_world_included
	#endinput
#endif
#define _satf_world_included

#include <a_samp>
#include <satf_colors>
#include <satf_players>
#include <satf_capturepoints>
#include <satf_classes>
#include <satf_maps>

#define BOUNDARIES_OUT_TIME 10

#define WORLD_BOUNDARIES_MAX_COORDS 4
#define WORLD_BOUNDARIES_MIN_X 0
#define WORLD_BOUNDARIES_MAX_X 1
#define WORLD_BOUNDARIES_MIN_Y 2
#define WORLD_BOUNDARIES_MAX_Y 3

new Float:satf_worldBoundaries[WORLD_BOUNDARIES_MAX_COORDS];

new satf_worldPlayerOutTime[MAX_PLAYERS];

initPlayerClasses() {
	for(new j = 0; j < 2; j++) {
	for(new i = 0; i < NUM_CLASSES; i++) {
		AddPlayerClass(satf_classes[i][SKIN],ENTRY_PLAYER_X,ENTRY_PLAYER_Y,ENTRY_PLAYER_Z,ENTRY_PLAYER_A,satf_classes[i][WEAPON0],satf_rank_properties[i][RANK_PRIVATE][AMMO0],satf_classes[i][WEAPON1],satf_rank_properties[i][RANK_PRIVATE][AMMO1],satf_classes[i][WEAPON2],satf_rank_properties[i][RANK_PRIVATE][AMMO2]);
	}
	}
}

deleteWorldBoundaries() {
	createWorldBoundaries(0.0,0.0,0.0,0.0);
}

createVehicle(model, color1, color2, respawntime, Float:x, Float:y, Float:z, Float:a) {
	vehicleSpawned[CreateVehicle(model,x,y,z,a,color1,color2,respawntime)] = true;
}

resetVehicles() {
	for(new i = 0; i < MAX_VEHICLES; i++) {
		if(vehicleSpawned[i])
			SetVehicleToRespawn(i);
	}
}

deleteVehicles() {
	for(new i = 0; i < MAX_VEHICLES; i++) {
		if(vehicleSpawned[i]) DestroyVehicle(i);
	}
}

createWorldBoundaries(Float:minX, Float:maxX, Float:minY, Float:maxY) {
	satf_worldBoundaries[WORLD_BOUNDARIES_MIN_X] = minX;
	satf_worldBoundaries[WORLD_BOUNDARIES_MAX_X] = maxX;
	satf_worldBoundaries[WORLD_BOUNDARIES_MIN_Y] = minY;
	satf_worldBoundaries[WORLD_BOUNDARIES_MAX_Y] = maxY;
}

isPlayerInWorldBoundaries(playerid) {
	if(satf_worldBoundaries[WORLD_BOUNDARIES_MIN_X] != 0.0 && satf_worldBoundaries[WORLD_BOUNDARIES_MAX_X] != 0.0 && satf_worldBoundaries[WORLD_BOUNDARIES_MIN_Y] != 0.0 && satf_worldBoundaries[WORLD_BOUNDARIES_MAX_Y] != 0.0) {
		if(satf_players[playerid][PLAYER_CLASS] == CLASS_SNIPER && spyundercover[playerid]) return 1;
		return isPlayerInsideArea(playerid, satf_worldBoundaries[WORLD_BOUNDARIES_MIN_X], satf_worldBoundaries[WORLD_BOUNDARIES_MAX_X], satf_worldBoundaries[WORLD_BOUNDARIES_MIN_Y], satf_worldBoundaries[WORLD_BOUNDARIES_MAX_Y]);
	} else {
		return 1;
	}
}

checkPlayersInWorldBoundaries() {
	new string[128];
	for(new i = 0; i < maxPlayers; i++) {
		if(isPlayerActive(i)) {
			if(!isPlayerInWorldBoundaries(i)) {
				if(satf_worldPlayerOutTime[i] == 0) {
					satf_worldPlayerOutTime[i] = BOUNDARIES_OUT_TIME;
					if(IsPlayerInAnyVehicle(i)) {
						new vehicleid = GetPlayerVehicleID(i);
						SetPlayerHealth(i, 0);
						SetVehicleHealth(vehicleid, 0);
					} else {
						SetPlayerHealth(i, 0);
					}
				} else if(playerAlive[i]) {
					format(string, sizeof(string), "~r~stay in combat zone or you get killed in %d seconds", satf_worldPlayerOutTime[i]);
					GameTextForPlayer(i, string, 1100, 3);
					satf_worldPlayerOutTime[i]--;
				}
			} else if(satf_worldPlayerOutTime[i] < BOUNDARIES_OUT_TIME) {
				satf_worldPlayerOutTime[i] = BOUNDARIES_OUT_TIME;
			}
		}
	}
}
