/* String functions
 *
 * (c) Copyright 2005, ITB CompuPhase
 * This file is provided as is (no warranties).
 */
#if defined _string_included
  #endinput
#endif
#define _string_included
#pragma library String

strlen(const string[])
{
	new i;
	while( string[i]!=0 )i++;
	return i;
}
native strpack(dest[], const source[], maxlength=sizeof dest);
native strunpack(dest[], const source[], maxlength=sizeof dest);
native strcat(dest[], const source[], maxlength=sizeof dest);

native strmid(dest[], const source[], start, end, maxlength=sizeof dest);
native bool: strins(string[], const substr[], pos, maxlength=sizeof string);
native bool: strdel(string[], start, end);

strcmp(const string1[], const string2[], bool:ignorecase=false, length=cellmax)
{
	new mbcs;

	for( new i=0; i<length; i++ )
	{
		new c1=string1[i], c2=string2[i];
		if( c1 < 0 ) c1+=256;
		if( c2 < 0 ) c2+=256;
		if( ignorecase && c1 <= 0x7F && c2 <= 0x7F && mbcs==0 )
		{
			c1 = tolower(c1);
			c2 = tolower(c2);
		}
		if(mbcs==1) mbcs=0;
		else if( c1 > 0x7F || c2 > 0x7F ) mbcs=1;
		
		if( c1 != c2 || (c1==0 && c2==0) ) return c1-c2;
	}
	
	return 0;
}
strfind(const string[], const sub[], bool:ignorecase=false, pos=0)
{
	new len = strlen(string), sublen = strlen(sub), count, mbcs, i;

	for( i=pos; i<=len && sublen-count<=len-i; i++ )
	{
		new c1=string[i], c2=sub[count];
		if( c1 < 0 ) c1+=256;
		if( c2 < 0 ) c2+=256;
		if( ignorecase && mbcs==0 )
		{
			c1 = tolower(c1);
			c2 = tolower(c2);
		}
		if(mbcs==1) mbcs=0;
		else if( c1 > 0x7F || c2 > 0x7F ) mbcs=1;

		if( c1 == c2 )
		{
			if( count == sublen-1 ) return i-count;
			count++;
		}
		else count = 0;
	}

	return -1;
}
#pragma unused strlen, strcmp, strfind

native strval(const string[]);
native valstr(dest[], value, bool:pack=false);
native bool: ispacked(const string[]);

native uudecode(dest[], const source[], maxlength=sizeof dest);
native uuencode(dest[], const source[], numbytes, maxlength=sizeof dest);
native memcpy(dest[], const source[], index=0, numbytes, maxlength=sizeof dest);
